;(function(){

	window._w.accessories = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.accessories.ti = _t[template];

			_w.accessories.initGrid();

			// Acccessory grid
			if (null == App.API.taskContract('gridAcccessory'))
			{
				App.API.getTask(
						'gridAcccessory', 'Stock', 'Accessory.List', null,
						{}, _w.accessories.loadAcccessoryGrid, _w.taskContractError
						);
			}
			else
			{
				_w.accessories.loadAcccessoryGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addAcccessory'))
			{
				App.API.getTask(
						'addAcccessory', 'Stock', 'Accessory.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.accessories.ti.hydrateParam('name', {
				type  : 'input',
				id    : 'name',
				title : 'Accessory',
				value : ''
			});
			_w.accessories._setupValidation();
		},

		initGrid : function()
		{

			_w.accessories.ti.hydrate({
				// Acccessory grid
				'gridAcccessoryTitle': 'Manage accessories',
				'gridAcccessoryColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Accessory: {
							id: 'gridAcccessoryColumn_Accessory',
							title: 'ACCESSORY'
						}
					}
				},
				'gridAcccessoryRowRepeater': {},
				'name' : {
					type  : 'input',
					id    : 'name',
					title : 'Accessory',
					value : ''
				}
			});

		},

		loadAcccessoryGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridAcccessory', data, options,
					_w.accessories._onAcccessoryGridDataReceived, _w.taskExecError
					);
		},

		_onAcccessoryGridDataReceived : function( response )
		{
			_w.accessories.ti.hydrateParam('gridAcccessoryRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					items: {
						'id'   : row.id,
						'Accessory' : row.name ? row.name : ''
					}
				});
			}
			_w.accessories.ti.hydrateParam('gridAcccessoryRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		orderAcccessoryGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.accessories.loadAcccessoryGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		_setupValidation : function ()
		{
			$('#frmAccessoryView').validate({
				"rules": {
					name: "required"
				},
				messages: {
					name : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = { Accessory: { name: $('#name').val() } };
					App.API.execTask(
							'addAcccessory', data, {},
							function() {
								$('#name').val('');
								_w.accessories.loadAcccessoryGrid( null, {}, {} );
								$('#btnSave').prop('disabled', false);
							}, _w.taskExecError
						);
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();