;(function(){

	window._w.divisions = {

		ti : null,
		itemId : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.divisions.ti = _t[template];
			_w.divisions.initGrid();

			App.DataStore.loadSelectListData('groups', false, 'Company', 'Group.SelectList');

			// Division grid
			if (null == App.API.taskContract('gridDivision'))
			{
				App.API.getTask(
						'gridDivision', 'Company', 'GroupDivision.List', null,
						{}, _w.divisions.loadDivisionGrid, _w.taskContractError
						);
			}
			else
			{
				_w.divisions.loadDivisionGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addDivision'))
			{
				App.API.getTask(
						'addDivision', 'Company', 'GroupDivision.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.divisions.ti.hydrateParam('group', {
				type  : 'select',
				id    : 'group',
				title : 'Group',
				value : '',
				dataStoreId : 'groups'
			});
			_w.divisions.ti.hydrateParam('name', {
				type  : 'input',
				id    : 'name',
				title : 'Name',
				value : ''
			});
			_w.divisions._setupValidation();
			$('#btnNew').click(function() {
				_w.divisions.itemId = null;
				$('#name').val('');
				$('#group').selectpicker('val', '');
				$('label.error').remove();
				$('#btnSave').html(' Add ');
			});
			$('#btnNew').prop('disabled', false);
		},

		initGrid : function()
		{

			_w.divisions.ti.hydrate({
				// Division grid
				'gridDivisionTitle': 'Manage divisions',
				'gridDivisionColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						group: {
							id: 'gridDivisionColumn_group',
							title: 'GROUP'
						},
						name: {
							id: 'gridDivisionColumn_name',
							title: 'NAME'
						}
					}
				},
				'gridDivisionRowRepeater': {}
			});

		},

		loadDivisionGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridDivision', data, options,
					_w.divisions._onDivisionGridDataReceived, _w.taskExecError
					);
		},

		_onDivisionGridDataReceived : function( response )
		{
			_w.divisions.gridData = {};
			_w.divisions.ti.hydrateParam('gridDivisionRowRepeater', {});
			var gridData = [];
			response.Data.sort(function(a, b)
			{
				var aName = a.group.name.toLowerCase();
				var bName = b.group.name.toLowerCase();
				return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
			});
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				_w.divisions.gridData[row.group.name] = row.group.id;
				gridData.push({
					prepend: {
						Amount  : 'R '
					},
					rowId : row.id,
					onClick : function(meta) {
						_w.divisions.itemId = meta.rowId;
						$('#name').val(meta.items.name);
						$('#group').selectpicker('val', _w.divisions.gridData[meta.items.group]);
						$('#btnSave').html(' Update ');
					},
					items: {
						'id' 			: row.id,
						'name' 			: row.name,
						'group' 		: row.group.name
					}
				});
			}
			_w.divisions.ti.hydrateParam('gridDivisionRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmDivisionView').validate({
				"rules": {
					name 			: "required",
					group 			: "required"
				},
				messages: {
					name 		: "This field is required.",
					group 		: "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = {
							GroupDivision: {
								name: $('#name').val(),
								group: $('#group').val(),
							}
					};
					if (null == _w.divisions.itemId)
					{
						App.API.execTask(
								'addDivision', data, {},
								function() {
									$('#name').val('');
									$('#group').selectpicker('val', '');
									$('label.error').remove();
									_w.divisions.loadDivisionGrid( null, {}, {} );
									$('#btnSave').prop('disabled', false);
									$('#btnSave').html(' Add ');
								}, _w.taskExecError
							);
					}
					else
					{
						App.API.getTask(
								'updateDivision' + _w.divisions.itemId, 'Company', 'GroupDivision.Update', null,
								{id: _w.divisions.itemId}, function () {
									App.API.execTask(
											'updateDivision' + _w.divisions.itemId, data, {},
											function() {
												$('#name').val('');
												$('#group').selectpicker('val', '');
												$('label.error').remove();
												_w.divisions.loadDivisionGrid( null, {}, {} );
												$('#btnSave').prop('disabled', false);
												$('#btnSave').html(' Add ');
											}, _w.taskExecError
										);
								}, _w.taskContractError
								);
					}
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();