;(function(){

    window._w.systemauctions = {

        ti       : null,
        gridData : {},

        onTemplateReady : function( template, event, eventData )
        {
            _w.systemauctions.ti = _t[template];
            App.DataStore.setData('auctionstatuses',
                [
                    {"value":"Active", "label":"Active"},
                    {"value":"Sold", "label":"Sold"},
                    {"value":"Relist", "label":"Relist"},
                    {"value":"Undone", "label":"Undone"},
                ]
            );
            _w.systemauctions.ti.hydrate({
                'gridTitle': 'Auction',
                'gridTitleSubtext': 'Please use the filters below to narrow down the view',
                'gridTitleButtons': {
                    constructor: 'Button',
                    items: {
                        Export: {
                            preset: 'GridExport',
                            id: 'exportAuctionGrid',
                            handler: _w.systemauctions.exportAuctionGrid
                        }
                    }
                },
                'gridContextFilter': {
                    constructor: 'GridContextFilter',
                    items: {
                        RegNum: {
                            title: 'Search here:',
                            style: 'filter-input-wrapper',
                            id: 'gridAuctionContext_RegNo',
                            placeholder: 'Registration number',
                            context: 'gridAuctionContext'
                        },
                        Buttons: {
                            actions: true,
                            searchId: 'searchAuctionGrid',
                            bindSearch: _w.systemauctions.searchAuctionGrid,
                            clearId: 'clearAuctionGridContext',
                            bindClear: _w.systemauctions.clearAuctionGridContext
                        }
                    }
                },
                'gridColumnHeaders': {
                    constructor: 'GridColumnHeader',
                    items: {
                        ID: {
                            id: 'gridAuctionColumn_ID',
                            title: 'ID',
                            orderAsc: {
                                id: 'gridAuctionOrder_IDAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'auction.id', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_IDDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'auction.id', 'DESC')
                            }
                        },
                        Make: {
                            id: 'gridAuctionColumn_Make',
                            title: 'MAKE',
                            orderAsc: {
                                id: 'gridAuctionOrder_MakeAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'make.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_MakeDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'make.name', 'DESC')
                            }
                        },
                        Model: {
                            id: 'gridAuctionColumn_Model',
                            title: 'MODEL',
                            orderAsc: {
                                id: 'gridAuctionOrder_ModelAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'model.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_ModelDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'model.name', 'DESC')
                            }
                        },
                        Type: {
                            id: 'gridAuctionColumn_Type',
                            title: 'TYPE',
                            orderAsc: {
                                id: 'gridAuctionOrder_TypeAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'type.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_TypeDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'type.name', 'DESC')
                            },
                            style: 'type'
                        },
                        Year: {
                            id: 'gridAuctionColumn_Year',
                            title: 'YEAR',
                            orderAsc: {
                                id: 'gridAuctionOrder_YearAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'vehicleYear.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_YearDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'vehicleYear.name', 'DESC')
                            },
                            style: 'year'
                        },
                        KM: {
                            id: 'gridAuctionColumn_KM',
                            title: 'KM&#39;S',
                            orderAsc: {
                                id: 'gridAuctionOrder_KMAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.km', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_KMDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.km', 'DESC')
                            },
                            style: 'kms'
                        },
                        Trade: {
                            id: 'gridAuctionColumn_Trade',
                            title: 'TRADE',
                            orderAsc: {
                                id: 'gridAuctionOrder_TradeAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.tradePrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_TradeDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.tradePrice', 'DESC')
                            }
                        },
                        Retail: {
                            id: 'gridAuctionColumn_Retail',
                            title: 'RETAIL',
                            orderAsc: {
                                id: 'gridAuctionOrder_RetailAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.retailPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_RetailDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.retailPrice', 'DESC')
                            }
                        },
                        List: {
                            id: 'gridAuctionColumn_List',
                            title: 'NEW LIST PRICE',
                            orderAsc: {
                                id: 'gridAuctionOrder_ListAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.listPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_ListDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'stock.listPrice', 'DESC')
                            }
                        },
                        Company: {
                            id: 'gridAuctionFilter_Company',
                            title: 'DEALERSHIP',
                            orderAsc: {
                                id: 'gridAuctionOrder_CompanyAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'company.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_CompanyDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'company.name', 'DESC')
                            }
                        },
                        Region: {
                            id: 'gridAuctionFilter_Region',
                            title: 'REGION',
                            orderAsc: {
                                id: 'gridAuctionOrder_RegionAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'region.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_RegionDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'region.name', 'DESC')
                            }
                        },
                        Bid: {
                            id: 'gridAuctionColumn_Bid',
                            title: 'HIGHEST BID',
                            orderAsc: {
                                id: 'gridAuctionOrder_BidAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'currentBid.amount', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_BidDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'currentBid.amount', 'DESC')
                            },
                            style: 'offer-submitted'
                        },
                        Time: {
                            id: 'gridAuctionColumn_Time',
                            title: 'TIME REMAINING'
                        },
                        Status: {
                            id: 'gridAuctionColumn_Status',
                            title: 'STATUS',
                            orderAsc: {
                                id: 'gridAuctionOrder_StatusAsc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'auction.jobState', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridAuctionOrder_StatusDesc',
                                bind: $.proxy(_w.systemauctions.orderAuctionGrid, this, 'auction.jobState', 'DESC')
                            }
                        },
                    }
                },
                'gridColumnFilters': {
                    constructor: 'GridColumnFilter',
                    items: {
                        ID: {
                            id: 'gridAuctionFilter_ID',
                            context: 'gridAuctionFilter'
                        },
                        Make: {
                            id: 'gridAuctionFilter_Make',
                            context: 'gridAuctionFilter'
                        },
                        Model: {
                            id: 'gridAuctionFilter_Model',
                            context: 'gridAuctionFilter'
                        },
                        Type: {
                            id: 'gridAuctionFilter_Type',
                            context: 'gridAuctionFilter'
                        },
                        Year: {
                            id: 'gridAuctionFilter_Year',
                            context: 'gridAuctionFilter'
                        },
                        KM: {
                            id: 'gridAuctionFilter_KM',
                            context: 'gridAuctionFilter'
                        },
                        Trade: {
                            id: 'gridAuctionFilter_Trade',
                            context: 'gridAuctionFilter'
                        },
                        Retail: {
                            id: 'gridAuctionFilter_Retail',
                            context: 'gridAuctionFilter'
                        },
                        List: {
                            id: 'gridAuctionColumn_List',
                            context: 'gridAuctionFilter'
                        },
                        Company: {
                            id: 'gridAuctionFilter_Company',
                            context: 'gridAuctionFilter'
                        },
                        Region: {
                            id: 'gridAuctionFilter_Region',
                            context: 'gridAuctionFilter'
                        },

                        Bid: {
                            id: 'gridAuctionFilter_Bid',
                            context: 'gridAuctionFilter'
                        },
                        Time: {},
                        Status: {
                            id: 'gridAuctionFilter_Status',
                            context: 'gridAuctionFilter',
                            dataStoreId : 'auctionstatuses',
                            selectEmpty : 'All'
                        },
                    }
                },
                'gridRowRepeater': {},
                'gridPager': {}
            });

            // Retrieve initial grid data.
            if (null == App.API.taskContract('gridAuction'))
            {
                App.API.getTask(
                    'gridAdminAuction', 'Auction', 'Auction.AdminGrid', null,
                    {}, _w.systemauctions.loadAuctionGrid, _w.taskContractError
                );
            }
            else
            {
                _w.systemauctions.loadAuctionGrid( null, {}, {} );
            }
        },

        onTemplatePublished : function()
        {
            $(".gridAuctionFilter").keypress(function (evt) {
                var charCode = evt.charCode || evt.keyCode;
                if (charCode  == 13) { //Enter key's keycode
                    $('#btnSearch').click();
                }
            });

            $('#exportAuctionGrid').prop('disabled', !App.permissions.pgGridExport);
            //$('#btnClearSearch').click(_w.systemauctions.clearAuctionGridContext);
            //$('#btnSearch').click(_w.systemauctions.searchAuctionGrid);

            var setTableFormWidth = function()
            {
                $('.table-form').css({
                    width : $(window).width() * 0.96
                });
            };

            $(window).on('resize', setTableFormWidth );
            setTableFormWidth();

            setTimeout(_w.systemauctions.refreshGrid, 30000);
        },

        refreshGrid : function()
        {
            if ('systemauctions' != App.activePage)
            {
                return;
            }
            _w.systemauctions.loadAuctionGrid( null, {}, {} );
            setTimeout(_w.systemauctions.refreshGrid, 30000);
        },

        pageAuctionGrid : function( page )
        {
            _w.systemauctions.loadAuctionGrid( {}, {"Grid":{"Page":page}} );
        },

        loadAuctionGrid : function( contract, data, options )
        {
            App.API.execTask(
                'gridAdminAuction', data, options,
                _w.systemauctions._onAuctionGridDataReceived, _w.taskExecError
            );
        },

        _buildGrid : function()
        {
            _w.systemauctions.ti.hydrateParam('gridRowRepeater', {
                constructor : 'GridDataRow',
                items	    : _w.systemauctions.gridData
            });
        },

        _onAuctionGridDataReceived : function( response )
        {
            _w.systemauctions.ti.hydrateParam('gridRowRepeater', {});
            _w.populateFilters(response.Data.Meta.Filters, {
                'id': 'gridAuctionFilter_ID',
                'make.name': 'gridAuctionFilter_Make',
                'model.name': 'gridAuctionFilter_Model',
                'type.name': 'gridAuctionFilter_Type',
                'vehicleYear.name': 'gridAuctionFilter_Year',
                'stock.km': 'gridAuctionFilter_KM',
                'stock.tradePrice': 'gridAuctionFilter_Trade',
                'stock.retailPrice': 'gridAuctionFilter_Retail',
                'stock.listPrice': 'gridAuctionFilter_List',
                'company.name': 'gridAuctionFilter_Company',
                'region.name': 'gridAuctionFilter_Region',
                'currentBid.amount': 'gridAuctionFilter_Bid',
                'auction.jobState': 'gridAuctionFilter_Status'
            });
            $('select.gridAuctionFilter').each(function(i, elem) {
                $(elem).selectpicker('refresh');
            });
            _w.systemauctions.gridData = {};
            for (var i = 0; i < response.Data.DataSet.length; i++)
            {
                var row = response.Data.DataSet[i];
                _w.systemauctions.gridData['i' + row.id] = {
                    url: 'systembidview',
                    prepend: {
                        Trade  : 'R ',
                        Retail : 'R ',
                        Bid    : 'R '
                    },
                    style: {},
                    items: {
                        'id'	  : row.id,
                        'ID'	  : row.id,
                        'Make'	  : row.stock.type.model.make.name,
                        'Model'   : row.stock.type.model.name,
                        'Type'	  : row.stock.type.name,
                        'Year'	  : row.stock.vehicleYear.name,
                        'KM'	  : row.stock.km,
                        'Trade'   : row.stock.tradePrice,
                        'Retail'  : row.stock.retailPrice,
                        'List'    : row.stock.listPrice,
                        'Company' : row.company.name,
                        'Region'  : row.company.city.region.name,
                        'Bid'     : row.currentBid ? row.currentBid.amount : row.reservePrice,
                        'Time'    : App.Util.calculateTimeLeft(row.created, null, row.endDate),
                        'Status'  : row.jobState
                    }
                };
            }
            _w.systemauctions._buildGrid();
            response.Data.Meta.itemName = 'stockPager';
            response.Data.Meta.bind = _w.systemauctions.pageAuctionGrid;
            _w.systemauctions.ti.hydrateParam('gridPager', {
                constructor : 'GridPager',
                items	    : [response.Data.Meta]
            });
        },

        exportAuctionGrid : function()
        {
            App.API.execTask(
                'gridAdminAuction', {}, {'ExportToExcel': true},
                _w.systemauctions._onExportReceived, _w.taskExecError,
                'EXPORT', true
            );
        },

        _onExportReceived : function( response )
        {
            var win = window.open();
            win.document.write(response);
        },

        clearAuctionGridContext : function()
        {
            try
            {
                $('select.gridAuctionFilter').each(function(i, elem) {
                    $(elem).selectpicker('val', '');
                    $(elem).selectpicker('refresh');
                });
            }
            catch (err) { console.log(err); }
            $('.gridAuctionContext').val('');
            $('.gridAuctionFilter').val('');
            _w.systemauctions.searchAuctionGrid(true);
        },

        searchAuctionGrid : function(resetOrder)
        {
            var filter = {
                count: 0,
                filters: {}
            };
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_ID', 'id');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Make', 'make.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Model', 'model.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Type', 'type.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Year', 'vehicleYear.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionContext_RegNo', 'stock.registrationNumber');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_KM', 'stock.km');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Trade', 'stock.tradePrice');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Retail', 'stock.retailPrice');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_List', 'stock.listPrice');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Company', 'company.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Region', 'region.name');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Bid', 'currentBid.amount');
            filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Status', 'auction.jobState');
            var request = {"Grid":{
                "Page": 1,
                "Filter": filter.filters
            }};
            if (resetOrder)
            {
                request.Grid.OrderBy = {'auction.created': 'DESC'};
            }

            _w.systemauctions.loadAuctionGrid( null, request, {} );
        },

        orderAuctionGrid : function(field, direction)
        {
            var order = {};
            order[field] = direction;
            _w.systemauctions.loadAuctionGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
        }
    };

})();