;(function(){

	window._w.systembidview = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		bidId         : null,
		bidData       : null,
		ti            : null,
		limited       : false,
		newItem       : false,
		nextBid       : false,
		bidType       : null,
		gridData      : {},

		onTemplateReady : function( template, event, eventData )
		{

			_w.systembidview.ti = _t[template];
			_w.systembidview.limited = ('limitedbidview' == template)
				? true
				: false;

			_w.systembidview.setStockViewFormMeta();
			_w.systembidview.ti.hydrate(_w.systembidview.formMeta);

			// Retrieve initial view data.
			_w.systembidview.itemId = App.Util.getUrlParam('id');
			_w.systembidview.bidId   = null;

			// Stock data
			var task = 'Auction.View';
			App.API.getTask(
				'viewAuction:' + _w.systembidview.itemId, 'Auction', task, _w.systembidview.itemId,
				{}, $.proxy( _w.systembidview._onStockViewDataReceived, this ), _w.taskContractError
			);

			// Bid history
			App.API.getTask(
					'gridBid' + _w.systembidview.itemId, 'Auction', 'Bid.Grid', _w.systembidview.itemId,
					{}, _w.systembidview.loadGrid, _w.taskContractError
					);
		},

		onTemplatePublished : function( template, event, eventData )
		{

			$('.mobile-header-bottom .bottom-heading').text('BID DETAILS');

			/*
			 * Permissions
			 */

			if (null != _w.systembidview.itemData)
			{
				_w.systembidview._onStockDataAndTemplate();
			}
			$('#btnRemove').click(function(){
				App.API.getTask(
						'removeAuction:' + _w.systembidview.itemId, 'Auction', 'Auction.Remove', _w.systembidview.itemId,
						{}, function(){
							App.API.execTask(
									'removeAuction:' + _w.systembidview.itemId, {}, {},
									function(){
										alert('Item removed from auction');
										window.location.hash = '/systemauctions';
									}, _w.taskExecError
									);
						}, _w.taskContractError
					);
			});
      
      $('#btnUndo').click(function(){
				App.API.getTask(
						'undoAuction:' + _w.systembidview.itemId, 'Auction', 'Auction.Undo', _w.systembidview.itemId,
						{}, function(){
							App.API.execTask(
									'undoAuction:' + _w.systembidview.itemId, {}, {},
									function(){
										alert('Auction Undone');
										window.location.hash = '/systemauctions';
									}, _w.taskExecError
									);
						}, _w.taskContractError
					);
			});
			setTimeout(_w.systembidview.refreshGrid, 30000);
		},

		refreshGrid : function()
		{
			if ('systembidview' != App.activePage)
			{
				return;
			}
			_w.systembidview.loadGrid( null, {}, {} );
			setTimeout(_w.systembidview.refreshGrid, 30000);
		},

		loadGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridBid' + _w.systembidview.itemId, data, options,
					_w.systembidview._onGridDataReceived, _w.taskExecError
					);
		},

		_onGridDataReceived : function( response )
		{
			_w.systembidview.ti.hydrateParam('gridRowRepeater', {});
			_w.systembidview.gridData = {};
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				_w.systembidview.gridData['i' + row.id] = {
					url: false,
					prepend: {
						Bid    : 'R '
					},
					style: {},
					items: {
						'id'	  : row.id,
						'Company' : row.company.name,
						'Profile' : row.profile.firstName + ' ' + row.profile.familyName,
						'Bid'     : row.amount,
						'Created' : row.created,
						'Status'  : row.status
					}
				};
			}
			_w.systembidview._buildGrid();
		},

		_buildGrid : function()
		{
			_w.systembidview.ti.hydrateParam('gridRowRepeater', {
				constructor : 'GridDataRow',
				items	    : _w.systembidview.gridData
			});
		},

		setStockViewFormMeta : function( data )
		{
			data = (undefined == data)
				? {"stock":{}}
				: data;
			var damagesHtml = '';
			var accessoriesHtml = '';
			if (undefined != data && undefined != data.stock && undefined != data.stock.damages)
			{
				for (var i = 0; i < data.stock.damages.length; i++)
				{
					damagesHtml += '<div class="control-group">';
					damagesHtml += '<label class="control-label valuation-line">' + data.stock.damages[i].damage.name + ':</label>';
					damagesHtml += '<div class="controls">';
					damagesHtml += '<p class="information-lines">R ' + data.stock.damages[i].amount + '</p>';
					damagesHtml += '</div>';
					damagesHtml += '</div>';
				}
			}
			if (undefined != data && undefined != data.stock && undefined != data.stock.accessories)
			{
				for (var i = 0; i < data.stock.accessories.length; i+=2)
				{
					var acc1 = data.stock.accessories[i]
						? data.stock.accessories[i].accessory.name
						: '&nbsp;';
					var acc2 = data.stock.accessories[i+1]
						? data.stock.accessories[i+1].accessory.name
						: '&nbsp;';
					accessoriesHtml += '<div class="row-fluid">';
					accessoriesHtml += '<div class="span6 textshow">' + acc1 + '</div>';
					accessoriesHtml += '<div class="span6 textshow">' + acc2 + '</div>';
					accessoriesHtml += '</div>';
				}
			}
			if (data.currentBidPrice)
			{
				_w.systembidview.nextBid = 0.0 == data.currentBidPrice
					? parseFloat(data.reservePrice) + parseFloat(data.bidIncrement)
					: parseFloat(data.currentBidPrice) + parseFloat(data.bidIncrement);
			}
			else
			{
				_w.systembidview.nextBid = 0.0;
			}
			_w.systembidview.formMeta = {
				'gridTitle': 'Bid History',
				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Company: {
							id: 'gridBidColumn_Company',
							title: 'DEALERSHIP'
						},
						Profile: {
							id: 'gridBidColumn_Profile',
							title: 'USER'
						},
						Bid: {
							id: 'gridBidColumn_Bid',
							title: 'BID AMOUNT',
							style: 'offer-submitted'
						},
						Created: {
							id: 'gridBidColumn_Created',
							title: 'CREATED'
						},
						Status: {
							id: 'gridBidColumn_Status',
							title: 'STATUS'
						}
					}
				},
				'gridRowRepeater': {},
				'vehicle' : data.stock.type
					? data.stock.type.model.make.name + ', '
							+ data.stock.type.model.name + ', '
							+ data.stock.type.name
					: '',
				'vehicleYear' : {
					title       : 'Year',
					value       : data.stock.vehicleYear ? data.stock.vehicleYear.name : ''
				},
				'category' : {
					title       : 'Category',
					value       : data.stock.type ? data.stock.type.category.name : ''
				},
				'make' : {
					title       : 'Vehicle Make',
					value       : data.stock.type ? data.stock.type.model.make.name : ''
				},
				'model' : {
					id          : 'vehicleModel',
					title       : 'Vehicle Model',
					value       : data.stock.type ? data.stock.type.model.name : ''
				},
				'type' : {
					title       : 'Vehicle Type',
					value       : data.stock.type ? data.stock.type.name : ''
				},
				'fuelType' : {
					title       : 'Fuel Type',
					value       : data.stock.fuelType ? data.stock.fuelType.name : ''
				},
				'transmissionType' : {
					title       : 'Transmission Type',
					value       : data.stock.transmissionType ? data.stock.transmissionType.name : ''
				},
				'condition' : {
					title       : 'Condition',
					value       : data.stock.condition ? data.stock.condition.name : ''
				},
				'exteriorColour' : {
					title       : 'Main ext. colour',
					value       : data.stock.exteriorColour ? data.stock.exteriorColour.name : ''
				},
				'interiorColour' : {
					title : 'Main int. colour',
					value : data.stock.interiorColour ? data.stock.interiorColour.name : ''
				},
				'upholstery' : {
					title       : 'Upholstery',
					value       : data.stock.upholstery ? data.stock.upholstery.name : ''
				},
				'papers' : {
					title       : 'Papers',
					value       : data.stock.papers ? data.stock.papers.name : ''
				},
				'natis' : {
					title       : 'Natis',
					value       : data.stock.natis ? data.stock.natis.name : ''
				},
				'spareKeys' : {
					title       : 'Spare keys',
					value       : undefined == data.stock.spareKeys
									? ''
									: (data.stock.spareKeys ? 'Yes' : 'No')
				},
				'fullServiceHistory' : {
					title       : 'Full service history',
					value       : undefined == data.stock.fullServiceHistory
									? ''
									: data.stock.fullServiceHistory.name
				},
				'registrationNumber' : {
					title : 'Registration no',
					value : data.stock.registrationNumber ? data.stock.registrationNumber : ''
				},
				'vinNumber' : {
					title : 'Vin no',
					value : data.stock.vinNumber ? data.stock.vinNumber : ''
				},
				'engineNumber' : {
					title : 'Engine no',
					value : data.stock.engineNumber ? data.stock.engineNumber : ''
				},
				'km' : {
					title : 'Kms',
					value : data.stock.km ? data.stock.km : ''
				},
				'fshNotes' : {
					title : 'FSH notes',
					value : data.stock.fshNotes ? data.stock.fshNotes : ''
				},
				'damages' : damagesHtml,
				'damageTotal' : {
					title : 'Total estimated repair price',
					value : 'R ' + (data.stock ? data.stock.damageTotal : '0.00')
				},
				'damageNotes' : {
					title : 'Damages comments',
					value : data.stock.damageNotes ? data.stock.damageNotes : ''
				},
				'previousRepairsNoted' : {
					title : 'Previous repairs noted',
					value : data.stock.previousRepairsNoted ? 'Yes' : 'No'
				},
				'previousRepairsNotes' : {
					title : 'Previous repairs comments',
					value : data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : ''
				},
				'accessories' : accessoriesHtml,
				'accessoryNotes' : {
					title     : 'Comments',
					value     : data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
				},
				'mainImage' : {
					type  : 'image',
					view  : true,
					id    : 'mainImage',
					baseImage : 'main_img_car.jpg',
					value : data.stock.mainImage ? data.stock.mainImage : ''
				},
				'frontImage' : {
					type  : 'image',
					view  : true,
					id    : 'frontImage',
					baseImage : 'front_car.jpg',
					value : data.stock.frontImage ? data.stock.frontImage : ''
				},
				'leftImage' : {
					type  : 'image',
					view  : true,
					id    : 'leftImage',
					baseImage : 'left_car.jpg',
					value : data.stock.leftImage ? data.stock.leftImage : ''
				},
				'rightImage' : {
					type  : 'image',
					view  : true,
					id    : 'rightImage',
					baseImage : 'right_car.jpg',
					value : data.stock.rightImage ? data.stock.rightImage : ''
				},
				'backImage' : {
					type  : 'image',
					view  : true,
					id    : 'backImage',
					baseImage : 'back_car.jpg',
					value : data.stock.backImage ? data.stock.backImage : ''
				},
				'interiorImage' : {
					type  : 'image',
					view  : true,
					id    : 'interiorImage',
					baseImage : 'interior_car.jpg',
					value : data.stock.interiorImage ? data.stock.interiorImage : ''
				},
				'engineImage' : {
					type  : 'image',
					view  : true,
					id    : 'engineImage',
					baseImage : 'engine_car.jpg',
					value : data.stock.engineImage ? data.stock.engineImage : ''
				},
				'natisImage' : {
					type  : 'image',
					view  : true,
					id    : 'natisImage',
					baseImage : 'copy_of_natis_car.jpg',
					value : data.stock.natisImage ? data.stock.natisImage : ''
				},

				'infCreated': data.created ? ((data.created).split(' '))[0] : '',
				'infLoadedOnAuction': data.stock.loadedOnAuction
					? ((data.stock.loadedOnAuction).split(' '))[0] : '',
				'infTradePrice': {
					title : 'Trade',
					value : data.stock.tradePrice ? 'R ' + data.stock.tradePrice : '0.00'
				},
				'infRetailPrice': {
					title : 'Retail',
					value : data.stock.retailPrice ? 'R ' + data.stock.retailPrice : '0.00'
				},
                'infListPrice': {
                    title : 'New list price',
                    value : data.stock.listPrice ? 'R ' + data.stock.listPrice : '0.00'
                },

				'companyName' : {
					title : 'Dealership name',
					value : data.company ? data.company.name : ''
				},
				'companyContact' : {
					title : 'Name and surname',
					value : data.company && data.company.contact
								? data.company.contact.firstName + ' ' + data.company.contact.familyName
								: ''
				},
				'companyMobile' : {
					title : 'Mobile',
					value : data.company && data.company.contact
								? data.company.contact.mobile
								: ''
				},
				'companyEmail' : {
					title : 'Email',
					value : data.company && data.company.contact
								? data.company.contact.email
								: ''
				},
				'amount' : {
					type  : 'input',
					id    : 'amount',
					title : 'Amount',
					value : _w.systembidview.nextBid,
					disabled: true
				},
				'autoamount' : {
					type  : 'input',
					id    : 'autoamount',
					title : 'Amount',
					//value : parseFloat(_w.systembidview.nextBid) + parseFloat(data.bidIncrement)
					value : parseFloat(_w.systembidview.nextBid).toPrecision(2) + parseFloat(data.bidIncrement).toPrecision(2)

				},
				'infAmount' : _w.systembidview.nextBid,
				'myAutoBid' : {
					title : 'Active auto-bid',
					value : data.currentBid && data.currentBid.autoBid

								? '<b>R ' + data.currentBid.autoBid.amount + '</b>'
								: '<b>no current auto-bid.</b>'
				},
				'nextBid' : {
					title : 'Next bid',
					value : '<b>R ' + _w.systembidview.nextBid + '</b>'
				},
				'winningBid' : {
					title : 'Winning bid',
					value : data.currentBid ? '<b>R ' + data.currentBid.amount + '</b>' : '<b>R 0.00</b>'
				},
				'status' : {
					title : 'Status',
					value : '<b>' + data.jobState + '</b>'
				},
				'print': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'Print',
							id: 'printAuctionPdf',
							handler: _w.systembidview.printAuctionPdf
						}
					}
				}
			};
		},

		printAuctionPdf : function()
		{
			App.API.getTask(
					'printAuctionPdf:' + _w.systembidview.itemId, 'Auction', 'Pdf.Print', _w.systembidview.itemId,
					{}, function() {
						App.API.execTask(
								'printAuctionPdf:' + _w.systembidview.itemId, {}, {},
								function () {}, _w.systembidview,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},

		_onBidDataAndTemplate : function ()
		{     
			if ('Archived' == _w.systembidview.bidData.status)
			{
				true == App.permissions.pgUnArchive ? $('#btnUnarchive').show() : $('#btnUnarchive').hide();
				$('#btnArchive').hide();
				$('#optMakeBid').hide();
			}
			else
			{
				true == App.permissions.pgArchive ? $('#btnArchive').show() : $('#btnArchive').hide();
				$('#btnUnarchive').hide();
			}
		},

		_onStockDataAndTemplate : function ()
		{
			if ('Active' != _w.systembidview.itemData.jobState)
			{
                $('#btnRemove').hide();
            }
            else
            {
                $('#btnRemove').show();
            }

            if ('Sold' != _w.systembidview.itemData.jobState)
                    {
                $('#btnUndo').hide();
            }
            else
            {
                $('#btnUndo').show();
            }

            if ('Active' != _w.systembidview.itemData.jobState)
			{
				$('#optMakeBid').hide();
			}
			else
			{
				App.API.getTask(
						'createBid', 'Auction', 'Bid.Create',
						_w.systembidview.itemId, {}, function(){}, _w.taskContractError
					);
				App.API.getTask(
						'createAutoBid', 'Auction', 'AutoBid.Create',
						_w.systembidview.itemId, {}, function(){}, _w.taskContractError
				);
			}
			$('div.table-header-wrapper').hide();
		},

		_onStockViewDataReceived : function( response )
		{
			_w.systembidview.itemId = response.Data.id;
			_w.systembidview.itemData = response.Data;
			_w.systembidview.setStockViewFormMeta(response.Data);
			_w.systembidview.ti.hydrate(_w.systembidview.formMeta);
			if (response.Data.currentBid)
			{
				console.log(response.Data.currentBid);
				_w.systembidview.bidId = response.Data.currentBid.id;
				_w.systembidview.bidData = response.Data.currentBid;
				if (_w.systembidview.bidData.company.id != App.companyData.id)
				{
					$('#bidSection').show();
				}
				else
				{
					$('#winningBid').show();
				}
			}
			else
			{
				$('#bidSection').show();
				_w.systembidview.newItem = true;
				_w.systembidview.bidData = {};
			}
			if (_w.systembidview.ti.published)
			{
				_w.systembidview._onStockDataAndTemplate();
			}
		},

		_onBidUpdated : function( response )
		{
			window.location.hash = '/auction';
		}

	};

})();