;(function(){

  _App.Controller = function( args )
  {
      this.initialize( args );
  };

  _App.Controller.prototype =
  {

      initialize : function( args )
      {
          for( var key in args )
          {
              this[key] = args[key];
          }

          this.getElems();
          this.setupScrollListener();
      },

      getElems : function()
      {
          this.$_head           = $('head');
          this.$_body           = $('body');
          this.$_htmlBody       = $('html, body');
          this.$_navAnchors     = $('#Header .nav a').map( function(i, a){ return $(a); });
      },

      changePage : function( pageName )
      {
    	  App.Event.trigger('Controller.LoadingTemplate:' + pageName, {"pageName": pageName});
    	  var prevPage = this.currentPage;
          this.currentPage = pageName || '';
          this.$_el.addClass('loading');
          //this.$_body.attr('id', this.currentPage.capitalize() + 'Page' );
          this.$_navAnchors.each(function(i, $_a)
        	{
	          if ( $_a.attr('href') == window.location.hash )
	          {
	              $_a.addClass('active');
	          }
	          else
	          {
	              $_a.removeClass('active');
	          }
          });
          $('div.hero-nav').remove();
          App.activePage = false;
          if (_t[prevPage])
    	  {
        	  App.Event.trigger('Controller.RemovingPage:' + prevPage, {"pageName": prevPage});
        	  _t[prevPage].remove();
        	  $('#PageContent').removeClass(prevPage);
    	  }
		  App.Template.register(
				  pageName, "page", pageName, 'PageContent', {},
				  $.proxy( this.renderPage, this )
				  );
      },

      renderPage : function( id, pageName )
      {
		  _t[pageName].publish();
    	  App.Event.trigger(
    			  'Controller.Published:' + pageName,
    			  {"id": "page", "pageName": pageName}
    			  );
          this.$_el.removeClass('loading');
          this.$_htmlBody.animate({
            'scrollTop' : 0
          }, 250);
          $('#PageContent').addClass(pageName);
          App.activePage = pageName;
      },

      setupScrollListener : function()
      {
          $(window).on('scroll', function() {
            if ( $(window).scrollTop() > 50 )
            {
            	$('#Header').addClass('compressed');
            }
            else
            {
            	$('#Header').removeClass('compressed');
            }
        });
      }

  };

})();