;(function(){

    window._w.stock = {

        ti : null,
        dfrom : '',
        dto   : '',
        gridStatus : null,

        onPageDestruct : function()
        {
            App.Event.removeListener('stockGridSuFilter', 'SuChange');

        },

        onStockPageTemplateReady : function( template, event, eventData )
        {
            _w.stock.ti = _t[template];
            App.DataStore.loadSelectListData('filtermakes', true, 'Stock', 'Make.SelectList');
            if (App.companyData.tC)
            {
                App.DataStore.setData('stockstatuses',
                    [
                        {"value":"Stock", "label":"Stock"},
                        {"value":"Auction", "label":"Auction"},
                        {"value":"Trade Center", "label":"Trade Center"},
                        {"value":"Sold", "label":"Sold"},
                        {"value":"Relist", "label":"Relist"},
                        {"value":"Price Guide", "label":"Price Guide"},
                        {"value":"Retail", "label":"Retail"},
                        {"value":"Archived", "label":"Archived"}
                    ]
                );
            }
            else
            {
                App.DataStore.setData('stockstatuses',
                    [
                        {"value":"Stock", "label":"Stock"},
                        {"value":"Auction", "label":"Auction"},
                        {"value":"Sold", "label":"Sold"},
                        {"value":"Relist", "label":"Relist"},
                        {"value":"Price Guide", "label":"Price Guide"},
                        {"value":"Retail", "label":"Retail"},
                        {"value":"Archived", "label":"Archived"}
                    ]
                );
            }
            _w.stock.ti.hydrate({
                'gridTitle': 'Stock Control',
                'gridTitleSubtext': 'Please use the filters below to narrow down the view',
                'gridTitleButtons': {
                    constructor: 'Button',
                    items: {
                        BulkImporter: {
                            preset: 'BulkImporter',
                            id: 'bulkImporterStockGrid',
                            handler: _w.stock.bulkImporterStockGrid
                        },
                        AuctionReport: {
                            preset: 'AuctionReport',
                            id: 'auctionReportStockGrid',
                            handler: _w.stock.auctionReportStockGrid
                        },
                        Export: {
                            preset: 'GridExport',
                            id: 'exportStockGrid',
                            handler: _w.stock.exportStockGrid
                        },
                        New: {
                            preset: 'NewStock',
                            id: 'newStock',
                            handler: _w.stock.newStock
                        }
                    }
                },
                'gridContextFilter': {
                    constructor: 'GridContextFilter',
                    items: {
                        RefNum: {
                            title: 'Search here:',
                            style: 'filter-input-wrapper',
                            id: 'gridStockContext_RefNo',
                            placeholder: 'Ref number',
                            context: 'gridStockContext'
                        },
                        RegNum: {
                            style: 'filter-input-wrapper',
                            id: 'gridStockContext_RegNo',
                            placeholder: 'Registration number',
                            context: 'gridStockContext'
                        },
                        DateFrom: {
                            style : 'input-append date filter-input-wrapper-date mobile-width12p dfrom',
                            title: 'Search date created here',
                            id: 'gridStockContext_DateFrom',
                            placeholder: 'From',
                            context: 'gridStockContext',
                            append: '<i class="icon-calendar"></i>',
                            readonly: true,
                            bind: function() {
                                $('#gridStockContext_DateFrom').change(function() {
                                    _w.stock.dFrom = $(this).val();
                                });
                            }
                        },
                        DateTo: {
                            style : 'input-append date filter-input-wrapper-date mobile-width12p dto',
                            id: 'gridStockContext_DateTo',
                            placeholder: 'To',
                            context: 'gridStockContext',
                            append: '<i class="icon-calendar"></i>',
                            readonly: true,
                            bind: function() {
                                $('#gridStockContext_DateTo').change(function() {
                                    _w.stock.dTo = $(this).val();
                                });
                            }
                        },
                        Buttons: {
                            actions: true,
                            searchId: 'searchStockGrid',
                            bindSearch: _w.stock.searchStockGrid,
                            clearId: 'clearStockGridContext',
                            bindClear: _w.stock.clearStockGridContext

                        },
                        RelistFilter: {
                            style : 'filter-input-wrapper hidden',
                            id: 'gridStockContext_RelistFilter',
                            placeholder: 'Relist Filter',
                            context: 'gridStockContext',
                            value: 'Relist,Undone'
                        }
                    }
                },
                'gridColumnHeaders': {
                    constructor: 'GridColumnHeader',
                    items: {
                        VIN: {
                            id: 'gridStockColumn_VIN',
                            title: 'VIN',
                            orderAsc: {
                                id: 'gridStockOrder_VinAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.vinNumber', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_VinDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.vinNumber', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Make: {
                            id: 'gridStockColumn_Make',
                            title: 'MAKE',
                            orderAsc: {
                                id: 'gridStockOrder_MakeAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'make.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_MakeDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'make.name', 'DESC')
                            },
                            style: 'make'
                        },
                        Model: {
                            id: 'gridStockColumn_Model',
                            title: 'MODEL',
                            orderAsc: {
                                id: 'gridStockOrder_ModelAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'model.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_ModelDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'model.name', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Type: {
                            id: 'gridStockColumn_Type',
                            title: 'TYPE',
                            orderAsc: {
                                id: 'gridStockOrder_TypeAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'type.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_TypeDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'type.name', 'DESC')
                            },
                            style: 'type'
                        },
                        Year: {
                            id: 'gridStockColumn_Year',
                            title: 'YEAR',
                            orderAsc: {
                                id: 'gridStockOrder_YearAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'vehicleYear.name', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_YearDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'vehicleYear.name', 'DESC')
                            },
                            style: 'year'
                        },
                        KM: {
                            id: 'gridStockColumn_KM',
                            title: 'KM&#39;S',
                            orderAsc: {
                                id: 'gridStockOrder_KmAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.km', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_KmDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.km', 'DESC')
                            },
                            style: 'kms hidden-phone'
                        },
                        Trade: {
                            id: 'gridStockColumn_Trade',
                            title: 'TRADE',
                            orderAsc: {
                                id: 'gridStockOrder_TradeAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.tradePrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_TradeDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.tradePrice', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Retail: {
                            id: 'gridStockColumn_Retail',
                            title: 'RETAIL',
                            orderAsc: {
                                id: 'gridStockOrder_RetailAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.retailPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_RetailDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.retailPrice', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Offer: {
                            id: 'gridStockColumn_Offer',
                            title: 'OFFER',
                            orderAsc: {
                                id: 'gridStockOrder_OfferAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.highestOffer', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_OfferDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.highestOffer', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Bid: {
                            id: 'gridStockColumn_Bid',
                            title: 'BID',
                            orderAsc: {
                                id: 'gridStockOrder_BidAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.highestBid', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_BidDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.highestBid', 'DESC')
                            },
                            style: 'hidden-phone'
                        },
                        Status: {
                            id: 'gridStockColumn_Status',
                            title: 'STATUS',
                            orderAsc: {
                                id: 'gridStockOrder_JobstateAsc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.jobState', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridStockOrder_JobstateDesc',
                                bind: $.proxy(_w.stock.orderStockGrid, this, 'stock.jobState', 'DESC')
                            }
                        }
                    }
                },
                'gridColumnFilters': {
                    constructor: 'GridColumnFilter',
                    items: {
                        VIN: {
                            id: 'gridStockFilter_VIN',
                            context: 'gridStockFilter'
                        },
                        Make: {
                            id: 'gridStockFilter_Make',
                            context: 'gridStockFilter',
                            dataStoreId : 'filtermakes',
                            selectEmpty : 'All',
                            bind : function(meta){
                                _w.stock.changes = 0;
                                $('#' + meta.id).change(function(){
                                    _w.stock.changes++;
                                    if (1 == _w.stock.changes || 'Active' != _w.stock.gridStatus)
                                    {
                                        return;
                                    }
                                    _w.stock.searchStockGrid();
                                });
                            }
                        },
                        Model: {
                            id: 'gridStockFilter_Model',
                            context: 'gridStockFilter'
                        },
                        Type: {
                            id: 'gridStockFilter_Type',
                            context: 'gridStockFilter'
                        },
                        Year: {
                            id: 'gridStockFilter_Year',
                            context: 'gridStockFilter'
                        },
                        KM: {
                            id: 'gridStockFilter_KM',
                            context: 'gridStockFilter'
                        },
                        Trade: {
                            id: 'gridStockFilter_Trade',
                            context: 'gridStockFilter'
                        },
                        Retail: {
                            id: 'gridStockFilter_Retail',
                            context: 'gridStockFilter'
                        },
                        Offer: {
                            id: 'gridStockFilter_Offer',
                            context: 'gridStockFilter'
                        },
                        Bid: {
                            id: 'gridStockFilter_Bid',
                            context: 'gridStockFilter'
                        },
                        Status: {
                            id: 'gridStockFilter_Status',
                            context: 'gridStockFilter',
                            dataStoreId : 'stockstatuses',
                            selectEmpty : 'All',
                            bind : function(meta){
                                _w.stock.changes = 0;
                                $('#' + meta.id).change(function(){
                                    _w.stock.changes++;
                                    if (1 == _w.stock.changes || 'Active' != _w.stock.gridStatus)
                                    {
                                        return;
                                    }
                                    _w.stock.searchStockGrid();
                                });
                            }
                        }
                    }
                },
                'gridRowRepeater': {},
                'gridPager': {}
            });

            // Retrieve initial grid data.
            if (null == App.API.taskContract('gridStock'))
            {
                App.API.getTask(
                    'gridStock', 'Stock', 'Stock.Grid', null,
                    {}, _w.stock.loadStockGrid, _w.taskContractError
                );
            }
            else
            {
                _w.stock.loadStockGrid( null, {}, {} );
            }
        },

        onStockPublished : function()
        {

            $(".gridStockFilter").keyup(function (evt) {
                var charCode = evt.charCode || evt.keyCode;
                if (charCode  == 13) { //Enter key's keycode
                    $('#searchStockGrid').click();
                }
            });

            $(".gridStockContext").keyup(function (evt) {
                var charCode = evt.charCode || evt.keyCode;
                if (charCode  == 13) { //Enter key's keycode
                    $('#searchStockGrid').click();
                }
            });

            var _p = App.permissions;
            var _createStockDisabled = false == _p.stockCreateNew && false == _p.stockCreateAuction
                ? true : false;
            $('#newStock').prop('disabled', _createStockDisabled);
            $('#exportStockGrid').prop('disabled', !App.permissions.stockGridExport);

            $('#bulkImporterStockGrid').prop('disabled', !App.permissions.stockBulkImportDrive || !App.permissions.stockBulkImportPinnacle);
            $('#bulkImporterStockGrid').hide();
            if(App.permissions.stockBulkImportDrive || App.permissions.stockBulkImportPinnacle)
            {
                $('#bulkImporterStockGrid').show();
            }

            $('#auctionReportStockGrid').prop('disabled', !App.permissions.stockAuctionReportGridExport);
            $('#auctionReportStockGrid').hide();
            if(App.permissions.stockAuctionReportGridExport)
            {
                $('#auctionReportStockGrid').show();
            }

            App.Event.listen('stockGridSuFilter', 'SuChange', $.proxy(_w.stock.loadStockGrid, this), 'Recurring');
            $('.dfrom').datepicker({format:"yyyy-mm-dd"});
            $('.dto').datepicker({format:"yyyy-mm-dd"});
            $('#gridStockContext_DateFrom').val(_w.stock.dFrom);
            $('#gridStockContext_DateTo').val(_w.stock.dTo);

            //setTimeout(_w.stock.refreshGrid, 120000);
        },

        refreshGrid : function()
        {
            return;
            if ('stock' != App.activePage)
            {
                return;
            }
            _w.stock.loadStockGrid( null, {}, {} );
            setTimeout(_w.stock.refreshGrid, 120000);
        },

        pageStockGrid : function( page )
        {
            _w.stock.loadStockGrid( {}, {"Grid":{"Page":page}} );
        },

        loadStockGrid : function( contract, data, options )
        {
            App.API.execTask(
                'gridStock', data, options,
                _w.stock._onStockGridDataReceived, _w.taskExecError
            );
        },

        _onStockGridDataReceived : function( response )
        {
            _w.stock.gridStatus = 'Active';
            _w.stock.ti.hydrateParam('gridRowRepeater', {});
            if (undefined != response.Data.Meta.Filters['auction.jobState'])
            {
                _w.populateFilters(response.Data.Meta.Filters, {
                    'stock.registrationNumber': 'gridStockContext_RegNo',
                    'stock.referenceNumber': 'gridStockContext_RefNo',
                    'stock.vinNumber': 'gridStockFilter_VIN',
                    'make.id': 'gridStockFilter_Make',
                    'model.name': 'gridStockFilter_Model',
                    'type.name': 'gridStockFilter_Type',
                    'vehicleYear.name': 'gridStockFilter_Year',
                    'stock.km': 'gridStockFilter_KM',
                    'stock.tradePrice': 'gridStockFilter_Trade',
                    'stock.retailPrice': 'gridStockFilter_Retail',
                    'stock.highestOffer': 'gridStockFilter_Offer',
                    'stock.highestBid': 'gridStockFilter_Bid',
                    'auction.jobState': 'gridStockFilter_Status'
                });
            }
            else
            {
                _w.populateFilters(response.Data.Meta.Filters, {
                    'stock.registrationNumber': 'gridStockContext_RegNo',
                    'stock.referenceNumber': 'gridStockContext_RefNo',
                    'stock.vinNumber': 'gridStockFilter_VIN',
                    'make.id': 'gridStockFilter_Make',
                    'model.name': 'gridStockFilter_Model',
                    'type.name': 'gridStockFilter_Type',
                    'vehicleYear.name': 'gridStockFilter_Year',
                    'stock.km': 'gridStockFilter_KM',
                    'stock.tradePrice': 'gridStockFilter_Trade',
                    'stock.retailPrice': 'gridStockFilter_Retail',
                    'stock.highestOffer': 'gridStockFilter_Offer',
                    'stock.highestBid': 'gridStockFilter_Bid',
                    'stock.jobState': 'gridStockFilter_Status'
                });
            }
            $('select.gridStockFilter').each(function(i, elem) {
                $(elem).selectpicker('refresh');
            });
            var gridData = [];
            for (var i = 0; i < response.Data.DataSet.length; i++)
            {
                var row = response.Data.DataSet[i];

                //console.log('row',row);

                gridData.push({
                    lineClass: 'handy',
                    surl: ('Stock' == row.jobState || ('Auction' == row.jobState && "0.00" == row.highestBid) || 'Relist' == row.jobState)

                        ? 'stockview' : 'limitedstockview',
                    prepend: {
                        Trade  : 'R ',
                        Retail : 'R ',
                        Offer  : 'R '
                    },
                    rowId: row.id,
                    pgId: row.priceGuide ? row.priceGuide.id : false,
                    offers:  row.priceGuide && row.priceGuide.offers
                        ? row.priceGuide.offers[0]
                        : null,
                    bind: function(meta) {
                        $('#row' +  meta.rowId).click(function(e){
                            window.location='#/' + meta.surl + '?id=' + meta.rowId;
                        });

                        $('#ofr' + meta.rowId).click(function(e) {
                            _w.PopUp = true;
                            e.preventDefault();
                            e.stopPropagation();
                            if (!meta.pgId)
                            {
                                var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no offers!</div>';
                                $('#modalbody').html(modalbody);
                                return;
                            }
                            else
                            {
                                $('#modalbody').html('<center>Loading offers...</center>');
                                $('#myModal').modal('toggle');
                            }
                            App.API.getTask(
                                'offerList', 'PriceGuide', 'Offer.List',
                                meta.pgId, {}, function(){
                                    App.API.execTask(
                                        'offerList', {}, {},
                                        function(response)
                                        {
                                            var offers = response.Data;
                                            if (offers.length)
                                            {
                                                var modalbody = '<table class="table table-bordered table-condensed table-striped">';
                                                modalbody += '<tr><td>Company</td><td>Date Offered</td><td>Amount</td></tr>';
                                                for (var x in offers)
                                                {
                                                    var isOwn = offers[x].company.id == App.companyData.id
                                                        ? true
                                                        : false;
                                                    modalbody +=
                                                        '<tr class="modalrow ' + (isOwn ? 'red' : 'black') + '">'
                                                        + '<td class="date">' + offers[x].company.name + '</td>'
                                                        + '<td class="date">' + offers[x].created + '</td>'
                                                        + '<td class="wide">' + offers[x].amount + '</td>'
                                                        + '</tr>';
                                                }
                                                modalbody += '</table>';
                                            }
                                            else
                                            {
                                                var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no offers!</div>';
                                            }
                                            $('#modalbody').html(modalbody);
                                        }, _w.taskExecError
                                    );
                                }, _w.taskContractError
                            );
                        });
                    },
                    style: {
                        VIN		: 'hidden-phone',
                        Make	: 'make',
                        Model	: 'hidden-phone',
                        Type	: 'type',
                        Year	: 'year',
                        KM		: 'hidden-phone',
                        Trade	: 'hidden-phone',
                        Retail	: 'hidden-phone',
                        Offer	: 'hidden-phone offer',
                        Bid		: 'hidden-phone',
                        Status	: 'status'

                    },
                    items: {
                        'id'     : row.id,
                        'VIN'    : row.vinNumber,
                        'Make'   : row.type.model.make.name,
                        'Model'  : row.type.model.name,
                        'Type'   : row.type.name,
                        'Year'   : row.vehicleYear.name,
                        'KM'     : row.km,
                        'Trade'  : row.tradePrice,
                        'Retail' : row.retailPrice,
                        'Offer'  : row.highestOffer + '&nbsp;&nbsp;&nbsp;<span id="ofr' + row.id + '">' + row.numberOfOffers + '</span>',
                        'Bid'    : row.highestBid,
                        'Status' : ('Stock' == row.jobState || 'Trade Center' == row.jobState) && row.auction && (row.auction.jobState == 'Undone' || row.auction.jobState == 'Relist') ? 'Relist' : row.jobState
                        //'Status' : row.auction.jobState == 'Undone' || row.auction.jobState == 'Relist' ? 'Relist' : row.jobState // Made this the same as portal-workspace/tcstock.js
                    }
                });
            }
            _w.stock.ti.hydrateParam('gridRowRepeater', {
                constructor : 'GridDataRow',
                items       : gridData
            });
            response.Data.Meta.itemName = 'stockPager';
            response.Data.Meta.bind = _w.stock.pageStockGrid;
            _w.stock.ti.hydrateParam('gridPager', {
                constructor : 'GridPager',
                items       : [response.Data.Meta]
            });
        },

        exportStockGrid : function()
        {
            App.API.execTask(
                'gridStock', {}, {'ExportToExcel': true},
                _w.stock._onExportReceived, _w.taskExecError,
                'EXPORT', true
            );
        },
        bulkImporterStockGrid  : function()
        {
            window.location.hash = '/stockbulkimporter';
        },
        auctionReportStockGrid : function()
        {
            window.location.hash = '/stockauctionreport';
        },

        newStock : function()
        {
            window.location.hash = '/stockview?id=0';
        },

        _onExportReceived : function( response )
        {
            var win = window.open();
            win.document.write(response);
        },

        clearStockGridContext : function()
        {
            _w.stock.gridStatus = 'Inactive';
            try
            {
                $('select.gridStockFilter').each(function(i, elem) {
                    $(elem).selectpicker('val', '');
                    $(elem).selectpicker('refresh');
                });
            }
            catch (err) { console.log(err); }
            $('.gridStockContext').val('');
            $('.gridStockFilter').val('');
            _w.stock.searchStockGrid(true);
        },

        searchStockGrid : function(resetOrder)
        {
            _w.stock.gridStatus = 'Inactive';
            var filter = {
                count: 0,
                filters: {}
            };
            filter = _w.filterIfnotEmpty(filter, 'gridStockContext_RegNo', 'stock.registrationNumber');
            filter = _w.filterIfnotEmpty(filter, 'gridStockContext_RefNo', 'stock.referenceNumber');
            filter = _w.filterIfnotEmpty(filter, 'gridStockContext_DateFrom', 'stock.created', '>=');
            filter = _w.filterIfnotEmpty(filter, 'gridStockContext_DateTo', 'stock.created', '<=', ' 23:59:59');

            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_VIN', 'stock.vinNumber');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Make', 'make.id');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Model', 'model.name');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Type', 'type.name');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Year', 'vehicleYear.name');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_KM', 'stock.km');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Trade', 'stock.tradePrice');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Retail', 'stock.retailPrice');
            filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Offer', 'stock.highestOffer');
            var status = $('#gridStockFilter_Status').val();
            if ('Undone' == status || 'Relist' == status)
            {
                $('#gridValuationContext_notArchived').val('Relist,Undone');
                filter = _w.filterIfnotEmpty(filter, 'gridStockContext_RelistFilter', 'auction.jobState', 'IN');
            }
            else
            {
                filter = _w.filterIfnotEmpty(filter, 'gridStockFilter_Status', 'stock.jobState');
            }
            var request = {"Grid":{
                "Page": 1,
                "Filter": filter.filters
            }};
            if (resetOrder)
            {
                request.Grid.OrderBy = {'stock.created': 'DESC'};
            }
            _w.stock.loadStockGrid( null, request, {} );
        },

        orderStockGrid : function(field, direction)
        {
            var order = {};
            order[field] = direction;
            _w.stock.loadStockGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
        }

    };

})();