;(function(){

	window._w.valuation = {

		ti : null,
		dfrom : '',
		dto   : '',
		gridStatus : null,

		onPageDestruct : function()
		{
			App.Event.removeListener('valuationGridSuFilter', 'SuChange');
		},

		onValuationPageTemplateReady : function( template, event, eventData )
		{
			_w.valuation.allowedDifference = 4000;
			_w.valuation.templateReadyTime = new Date().getTime();
			var newtitle = 'RETAIL';
			var newtitle2 = 'OFFER';

			if ('Dealership Sales' == App.permissions.name) {
				var newtitle = 'HIGEST PRICE GUIDE OFFER';
				var newtitle2 = 'MANAGER\'s OFFER';
			}
			_w.valuation.ti = _t[template];
			App.DataStore.loadSelectListData('filtermakes', true, 'Stock', 'Make.SelectList');
			App.DataStore.loadSelectListData('sales', false, 'User', 'Profile.SalesList');
			App.DataStore.loadSelectListData('managers', false, 'User', 'Profile.ManagerList');
			App.DataStore.setData('valuationstatuses',
					[
					 {"value":"New Valuation", "label":"New Valuation"},
					 {"value":"Pending Valuation", "label":"Pending Valuation"},
					 {"value":"Complete Valuation", "label":"Complete Valuation"},
					 {"value":"Offer Accepted", "label":"Offer Accepted"},
					 {"value":"Deal Done", "label":"Deal Done"},
					 {"value":"Deal Not Done", "label":"Deal Not Done"},
					 {"value":"Price Guide", "label":"Price Guide"},
					 {"value":"Archived", "label":"Archived"}
					 ]
			);

			App.DataStore.setData('archivedStatuses',
					[
					 {"value":"includingArchived", "label":"View all vehicles including archived"},
					 {"value":"excludingArchived", "label":"View all vehicles excluding archived"},
					 {"value":"onlyArchived", "label":"View only archived"}
					 ]
			);

			_w.valuation.ti.hydrate({
				'gridTitle': 'Valuations',
				'gridTitleSubtext': 'Please use the filters below to narrow down the view',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Report: {
							permission: App.permissions.settingsReport,
							preset: 'ValuationReport',
							id: 'valuationReport',
							handler: _w.valuation.valuationReport
						},
						Export: {
							preset: 'GridExport',
							id: 'exportValuationGrid',
							handler: _w.valuation.exportValuationGrid
						},
						New: {
							preset: 'NewValuation',
							id: 'newValuation',
							handler: _w.valuation.newValuation
						}
					}
				},
				'gridContextFilter': {
					constructor: 'GridContextFilter',
					items: {
						VinNum: {
							title: 'Search here:',
							style : 'filter-input-wrapper hidden-phone',
							id: 'gridValuationContext_VIN',
							placeholder: 'VIN number',
							context: 'gridValuationContext'
						},
						RefNum: {
							style : 'filter-input-wrapper hidden-phone',
							id: 'gridValuationContext_RefNo',
							placeholder: 'Ref number',
							context: 'gridValuationContext'
						},
						RegNum: {
							style : 'filter-input-wrapper hidden-phone',
							id: 'gridValuationContext_RegNo',
							placeholder: 'Registration number',
							context: 'gridValuationContext'
						},
						RegNumMobi: {
							style : 'filter-input-wrapper hidden-desktop',
							id: 'gridValuationContext_RegNoMobi',
							placeholder: 'Registration number',
							context: 'gridValuationContext'
						},
						Name: {
							style : 'filter-input-wrapper hidden-phone',
							id: 'gridValuationContext_Name',
							placeholder: 'Customer Surname',
							context: 'gridValuationContext'
						},
						DateFrom: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dfrom hidden-phone',
							title: 'Search date created here',
							id: 'gridValuationContext_DateFrom',
							placeholder: 'From',
							context: 'gridValuationContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridValuationContext_DateFrom').change(function() {
									_w.valuation.dFrom = $(this).val();
								});
							}
						},
						DateTo: {
							style : 'input-append date filter-input-wrapper-date mobile-width12p dto hidden-phone',
							id: 'gridValuationContext_DateTo',
							placeholder: 'To',
							context: 'gridValuationContext',
							append: '<i class="icon-calendar"></i>',
							readonly: true,
							bind: function() {
								$('#gridValuationContext_DateTo').change(function() {
									_w.valuation.dTo = $(this).val();
								});
							}
						},
						MakeMobi: {
							style: 'filter-input-wrapper filter-input-select',
							placeholder: 'Make Mobi',
							id: 'gridPriceGuideContext_MakeMobi',
							context: 'gridValuationContext',
							dataStoreId : 'filtermakes',
							selectEmpty : 'All Makes',
							style: 'MakeMobi hidden-desktop ',
							bind : function(meta){
								$('#gridAuctionFilter_MakeMobi').change(function(){
									$('#gridAuctionFilter_Make').selectpicker('val', $(this).val());
								});
							}
						},
						// status
						Status: {
							style: 'filter-input-wrapper filter-input-select ',
							placeholder: 'status Mobi',
							id: 'gridValuationContext_StatusMobi',
							context: 'gridValuationContext',
							dataStoreId : 'valuationstatuses',
							selectEmpty : 'All',
							style: 'StatusMobi hidden-desktop ',
							bind : function(meta){
								$('#gridValuationContext_StatusMobi').change(function()
								{
									$('#gridValuationFilter_Status').selectpicker('val', $(this).val());
								});
							}
						},

						ValuationNotArchived: {
							style : 'filter-input-wrapper hidden',
							id: 'gridValuationContext_notArchived',
							placeholder: 'Valuation Not Archived',
							context: 'gridValuationContext',
							value: 'Archived,Stock'
						},

						Archived: {
							style: 'filter-input-wrapper filter-input-select ',
							placeholder: 'Archived ',
							id: 'gridValuationContext_Archived',
							context: 'gridValuationContext',
							dataStoreId : 'archivedStatuses',
							value: 'excludingArchived',
							style: 'Archived hidden-phone hidden-tablet',
							bind : function(meta){
								$('#gridValuationContext_Archived').change(function(){
									_w.valuationsArchiveDrop = $(this).val();
									if ($(this).val() == 'includingArchived')
									{
										//includingArchived
										//remove the excludingArchived input value in hidden field
										$('#gridValuationContext_notArchived').val('');
										//set the grid filter status to All and show
										if (!_w.valuation.statusMenuOverride)
										{
											$('#gridValuationFilter_Status').selectpicker('val', 'All');
										}
										$('[data-id="gridValuationFilter_Status"]').removeClass("hidden");

									}
									if ($(this).val() == 'excludingArchived')
									{
										$('[data-id="gridValuationFilter_Status"]').removeClass("hidden");
										//excludingArchived
										// The not Archive view all and trigger search
										// Has operator in seach !(not) so search for Archive only
										$('#gridValuationContext_notArchived').val('Archived,Stock');
										if ('All' != $('#gridValuationFilter_Status').selectpicker('val'))
										{
											if (!_w.valuation.statusMenuOverride)
											{
												$('#gridValuationFilter_Status').selectpicker('val', 'All');
											}
										}
										_w.valuation.searchValuationGrid();
									}
									if ($(this).val() == 'onlyArchived')
									{
										//onlyArchived
										//remove the excludingArchived input value in hidden field
										$('#gridValuationContext_notArchived').val('');
										//set the grid filter status to Archived and hide
										if (!_w.valuation.statusMenuOverride)
										{
											$('#gridValuationFilter_Status').selectpicker('val', 'Archived');
										}
										//data-id = gridValuationFilter_Status hide
										$('[data-id="gridValuationFilter_Status"]').addClass("hidden");
									}
									_w.valuation.statusMenuOverride = false;



								});
							}
						},

						Buttons: {
							actions: true,
							clearId: 'clearValuationGridContext',
							bindClear: _w.valuation.clearValuationGridContext,
							searchId: 'searchValuationGrid',
							bindSearch: _w.valuation.searchValuationGrid
						}
					}
				},
				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Make: {
							id: 'gridValuationColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridValuationOrder_MakeAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_MakeDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'make.name', 'DESC')
							},
							style: 'hidden-phone'
						},
						Model: {
							id: 'gridValuationColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridValuationOrder_ModelAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_ModelDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'model.name', 'DESC')
							},
							style: 'hidden-phone'
						},
						Type: {
							id: 'gridValuationColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridValuationOrder_TypeAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_TypeDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'type.name', 'DESC')
							},
							style: 'type'

						},
						Year: {
							id: 'gridValuationColumn_Year',
							title: 'YEAR',
							orderAsc: {
								id: 'gridValuationOrder_YearAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'vehicleYear.name', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_YearDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'vehicleYear.name', 'DESC')
							},
							style : 'year'
						},
						KM: {
							id: 'gridValuationColumn_KM',
							title: 'KM&#39;S',
							orderAsc: {
								id: 'gridValuationOrder_KMAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.km', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_KMDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.km', 'DESC')
							},
							style : 'hidden-phone kms'
						},
						Trade: {
							id: 'gridValuationColumn_Trade',
							title: 'TRADE',
							orderAsc: {
								id: 'gridValuationOrder_TradeAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.tradePrice', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_TradeDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.tradePrice', 'DESC')
							},
							style : 'hidden-phone'
						},
						Retail: {
							id: 'gridValuationColumn_Retail',
							title: newtitle,
							orderAsc: {
								id: 'gridValuationOrder_RetailAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.retailPrice', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_RetailDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.retailPrice', 'DESC')
							},
							style: 'hidden-phone'
						},
                        List: {
                            id: 'gridValuationColumn_List',
                            title: 'NEW LIST PRICE',
                            orderAsc: {
                                id: 'gridValuationOrder_ListAsc',
                                bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.listPrice', 'ASC')
                            },
                            orderDesc: {
                                id: 'gridValuationOrder_ListDesc',
                                bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.listPrice', 'DESC')
                            },
                            style : 'hidden-phone'
                        },
						Offer: {
							id: 'gridValuationColumn_Offer',
							title: newtitle2,
							orderAsc: {
								id: 'gridValuationOrder_OfferAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.highestOffer', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_OfferDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'stock.highestOffer', 'DESC')
							},
							style: 'offer'
						},
						Sales: {
							id: 'gridValuationColumn_Sales',
							title: 'SALES',
							orderAsc: {
								id: 'gridValuationOrder_SalesAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'salesProfile.id', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_SalesDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'salesProfile.id', 'DESC')
							},
							style : 'hidden-phone'
						},
						Manager: {
							id: 'gridValuationColumn_Manager',
							title: 'MANAGER',
							orderAsc: {
								id: 'gridValuationOrder_ManagerAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'managerProfile.id', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_ManagerDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'managerProfile.id', 'DESC')
							},
							style : 'hidden-phone'
						},
						Status: {
							id: 'gridValuationColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridValuationOrder_StatusAsc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'valuation.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridValuationOrder_StatusDesc',
								bind: $.proxy(_w.valuation.orderValuationGrid, this, 'valuation.jobState', 'DESC')
							},
							style: 'status'
						},
					}
				},
				'gridColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Make: {
							id: 'gridValuationFilter_Make',
							context: 'gridValuationFilter',
							dataStoreId : 'filtermakes',
							selectEmpty : 'All',
							bind : function(meta){
								_w.valuation.changes = 0;
								$('#' + meta.id).change(function(e){
									_w.valuation.changes++;
									if (undefined == $(e.currentTarget).val() || 1 == _w.valuation.changes || 'Active' != _w.valuation.gridStatus)
									{
										return;
									}
									_w.valuation.searchValuationGrid();
								});
							}
						},
						Model: {
							id: 'gridValuationFilter_Model',
							context: 'gridValuationFilter'
						},
						Type: {
							id: 'gridValuationFilter_Type',
							context: 'gridValuationFilter'
						},
						Year: {
							id: 'gridValuationFilter_Year',
							context: 'gridValuationFilter'
						},
						KM: {
							id: 'gridValuationFilter_KM',
							context: 'gridValuationFilter'
						},
						Trade: {
							id: 'gridValuationFilter_Trade',
							context: 'gridValuationFilter'
						},
						Retail: {
							id: 'gridValuationFilter_Retail',
							context: 'gridValuationFilter'
						},
						Offer: {
							id: 'gridValuationFilter_Offer',
							context: 'gridValuationFilter'
						},
						Sales: {
							id: 'gridValuationFilter_Sales',
							context: 'gridValuationFilter',
							dataStoreId : 'sales',
							selectEmpty : 'All',
							bind : function(meta){
								_w.valuation.changes = 0;
								$('#' + meta.id).change(function(e)
								{
									if (_w.valuation.publishing || App.DataStore.getItem('BuildSelect:gridValuationFilter_Sales', false))
									{
										return;
									}
									_w.valuation.searchValuationGrid();
								});
							}
						},
						Manager: {
							id: 'gridValuationFilter_Manager',
							context: 'gridValuationFilter',
							dataStoreId : 'managers',
							selectEmpty : 'All',
							bind : function(meta){
								_w.valuation.changes = 0;
								$('#' + meta.id).change(function(e)
								{
									if (_w.valuation.publishing || App.DataStore.getItem('BuildSelect:gridValuationFilter_Manager', false))
									{
										return;
									}
									_w.valuation.searchValuationGrid();
								});
							}
						},
						Status: {
							id: 'gridValuationFilter_Status',
							context: 'gridValuationFilter',
							dataStoreId : 'valuationstatuses',
							selectEmpty : 'All',
							bind : function(meta){
								_w.valuation.changes = 0;
								$('#' + meta.id).change(function(){
									if (_w.valuation.publishing || App.DataStore.getItem('BuildSelect:gridValuationFilter_Status', false))
									{
										return;
									}
									
									if (!_w.valuation.statusMenuOverride)
									{
										_w.valuation.searchValuationGrid();
									}

									if ($(this).val() == 'Archived')
									{
										_w.valuation.statusMenuOverride = true;
										$('#gridValuationContext_Archived').selectpicker('val', 'onlyArchived');										
									}

								});
							}
						},
					}
				},
				'gridRowRepeater': {},
				'gridPager': {}
			});

			// Retrieve initial grid data.
			_w.valuation.publishing = true;
			if (null == App.API.taskContract('gridValuation'))
			{
				/*App.API.getTask(
						'gridValuation', 'Valuation', 'Valuation.Grid', null,
						{}, $.proxy(_w.valuation.searchValuationGrid, this, null, {}, {}), _w.taskContractError
						);*/
			App.API.getTask(
						'gridValuation', 'Valuation', 'Valuation.Grid', null,
						{}, _w.valuation.loadValuationGrid, _w.taskContractError
						);
			}
			else
			{
				_w.valuation.loadValuationGrid();
			}
		},

		onValuationsPublished : function()
		{

			// Show new menu Buttons for mobi only
			var isMobile = 'none' == $('.header').css('display');
			if (isMobile)
			{
				// show the mobi menu && hide old menu
				$("#MobiAuctionPriceGuideMenu").show();
				$("#MobiPortalMenu").hide();

				// Check active state
				$("#mobiAuctionBtn").removeClass("active");
				$("#mobiPriceGuideBtn").removeClass("active");
				$("#mobiValuationsBtn").addClass("active");
			}

			$("#mobiPriceGuideBtn").click(function() {
				window.location.hash = '#/priceguide';
			});

			$("#mobiAuctionBtn").click(function() {
				window.location.hash = '#/auction';
			});


			if (_w.valuationsArchiveDrop)
			{
				$('#gridValuationContext_Archived').selectpicker('val', _w.valuationsArchiveDrop);
			}


			$(".gridValuationFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#searchValuationGrid').click();
				}
			});

			$(".gridValuationContext").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#searchValuationGrid').click();
				}
			});
			$('#gridValuationContext_notArchived').val('Archived,Stock');

			var _p = App.permissions;
			var _createValuationDisabled = (false == _p.valuationCreateNew        && false == _p.valuationCreatePending
										 && false == _p.valuationCreatePriceguide && false == _p.valuationCreateSales
										 && false == _p.valuationCreateStock) 	  ? true : false ;

			$('#newValuation').prop('disabled', _createValuationDisabled);
			$('#exportValuationGrid').prop('disabled', !App.permissions.valuationGridExport);

			$('.dfrom').datepicker({format:"yyyy-mm-dd"});
			$('.dto').datepicker({format:"yyyy-mm-dd"});
			$('#gridValuationContext_DateFrom').val(_w.valuation.dFrom);
			$('#gridValuationContext_DateTo').val(_w.valuation.dTo);
			App.Event.listen('valuationGridSuFilter', 'SuChange', $.proxy(_w.valuation.clearValuationGridContext, this), 'Recurring');

			_w.valuation.publishing = false;
			setTimeout(_w.valuation.refreshGrid, 120000);

		},

		refreshGrid : function()
		{
			if ('valuations' != App.activePage)
			{
				return;
			}
			_w.valuation.loadValuationGrid();
			setTimeout(_w.valuation.refreshGrid, 120000);
		},

		pageValuationGrid : function( page )
		{
			_w.valuation.loadValuationGrid( {}, {"Grid":{"Page":page}} );
		},

		loadValuationGrid : function( contract, data, options )
		{
			//console.log('Filter  value is', $('#gridValuationContext_Archived').val());
			if ($('#gridValuationFilter_Status').val() == 'excludingArchived')
			{
				$('#gridValuationContext_notArchived').val('Archived,Stock');
				if (undefined == data)
				{
					data = {};
				}
				if (undefined == data.Grid)
				{
					data.Grid = {};
				}
				if (undefined == data.Grid.Filter)
				{
					data.Grid.Filter = {};
				}
				data.Grid.Filter['valuation.jobState'] = 'NOT IN Archived,Stock';
			}
			//This comes back undefined if you are from a different page back to valuations
	/*		if ($('#gridValuationContext_Archived').val() == undefined)
			{
				data.Grid.Filter['valuation.jobState'] = 'NOT IN Archived,Stock';
			}
*/
			App.API.execTask(

					'gridValuation', data, options,
					_w.valuation._onValuationGridDataReceived, _w.taskExecError
					);

		},

		_onValuationGridDataReceived : function( response )
		{

		
			console.log('Filter responses ',response.Data.Meta.Filters);
			
			_w.valuation.gridStatus = 'Active';
			_w.valuation.ti.hydrateParam('gridRowRepeater', {});
			var statuses = {
				"New Valuation": true,
				"Pending Valuation": true,
				"Complete Valuation": true,
				"Offer Accepted": true,
				"Deal Done": true,
				"Deal Not Done": true,
				"Price Guide": true,
				"Archived": true
			};
			if (undefined != response.Data.Meta.Filters['valuation.jobState']
				&& undefined != statuses[response.Data.Meta.Filters['valuation.jobState']])
			{
				_w.populateFilters(response.Data.Meta.Filters, {
					'stock.vinNumber': 'gridValuationContext_VIN',
					'stock.registrationNumber': 'gridValuationContext_RegNo',
					'stock.referenceNumber': 'gridValuationContext_RefNo',
					'valuation.familyName': 'gridValuationContext_Name',
					'make.id': 'gridValuationFilter_Make',
					'model.name': 'gridValuationFilter_Model',
					'type.name': 'gridValuationFilter_Type',
					'vehicleYear.name': 'gridValuationFilter_Year',
					'stock.km': 'gridValuationFilter_KM',
					'stock.tradePrice': 'gridValuationFilter_Trade',
					'stock.retailPrice': 'gridValuationFilter_Retail',
                    'stock.listPrice': 'gridValuationFilter_List',
					'stock.highestOffer': 'gridValuationFilter_Offer',
					'salesProfile.id': 'gridValuationFilter_Sales',
					'managerProfile.id': 'gridValuationFilter_Manager',
					'valuation.jobState':  'gridValuationFilter_Status'
				});
			}
			else
			{
				_w.populateFilters(response.Data.Meta.Filters, {
					'stock.vinNumber': 'gridValuationContext_VIN',
					'stock.registrationNumber': 'gridValuationContext_RegNo',
					'stock.referenceNumber': 'gridValuationContext_RefNo',
					'valuation.familyName': 'gridValuationContext_Name',
					'make.id': 'gridValuationFilter_Make',
					'model.name': 'gridValuationFilter_Model',
					'type.name': 'gridValuationFilter_Type',
					'vehicleYear.name': 'gridValuationFilter_Year',
					'stock.km': 'gridValuationFilter_KM',
					'stock.tradePrice': 'gridValuationFilter_Trade',
					'stock.retailPrice': 'gridValuationFilter_Retail',
                    'stock.listPrice': 'gridValuationFilter_List',
					'stock.highestOffer': 'gridValuationFilter_Offer',
					'salesProfile.id': 'gridValuationFilter_Sales',
					'managerProfile.id': 'gridValuationFilter_Manager'
				});
			}
//valuation.jobState = "NOT IN Archived,Stock" >> excluding archived
//valuation.jobState = "Archived" >> only archived
			/*if (undefined == response.Data.Meta.Filters['valuation.jobState'])
			{
				_w.valuation.statusMenuOverride = true;
				$('#gridValuationContext_Archived').selectpicker('val', 'includingArchived');
			}
			else if ('NOT IN Archived,Stock' == response.Data.Meta.Filters['valuation.jobState'])
			{
				_w.valuation.statusMenuOverride = true;
				$('#gridValuationContext_Archived').selectpicker('val', 'excludingArchived');
			}
			else if ('Archived' == response.Data.Meta.Filters['valuation.jobState'])
			{
				_w.valuation.statusMenuOverride = true;
				$('#gridValuationContext_Archived').selectpicker('val', 'onlyArchived');
			}*/
			

		
			

			$('select.gridValuationFilter').each(function(i, elem) {
				$(elem).selectpicker('refresh');
				// Error: Resets status when status should be populated gridStockFilter
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					lineClass: 'handy',
					surl: (
							'New Valuation'         == row.jobState
							|| 'Pending Valuation'  == row.jobState
							|| 'Complete Valuation' == row.jobState
							|| 'Deal Not Done'      == row.jobState
							|| ('Price Guide' == row.jobState
									&& row.stock.numberOfOffers == 0)
					)
						? 'valuationview'
						: 'limitedvaluationview',
					prepend: {
						Trade  : 'R ',
						Retail : 'R ',
						Offer  : 'R '
					},
					rowId: row.id,
					pgId: row.stock.priceGuide.id,
					offers:  row.stock.priceGuide && row.stock.priceGuide.offers
						? row.stock.priceGuide.offers[0]
						: null,
					bind: function(meta) {
						$('#row' +  meta.rowId).click(function(e){
							window.location='#/' + meta.surl + '?id=' + meta.rowId;
						});

						$('#ofr' + meta.rowId).click(function(e) {
							_w.PopUp = true;
							e.preventDefault();
							e.stopPropagation();
							if (!meta.pgId)
							{
								var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no offers!</div>';
								$('#modalbody').html(modalbody);
								return;
							}
							else
							{
								$('#modalbody').html('<center>Loading offers...</center>');
								$('#myModal').modal('toggle');
							}
							App.API.getTask(
									'offerList', 'PriceGuide', 'Offer.List',
									meta.pgId, {}, function(){
										App.API.execTask(
												'offerList', {}, {},
												function(response)
												{
													var offers = response.Data;
													if (offers.length)
													{
														var modalbody = '<table class="table table-bordered table-condensed table-striped">';
														modalbody += '<tr><td>Company</td><td>Date Offered</td><td>Amount</td></tr>';
														for (var x in offers)
														{
															var isOwn = offers[x].company.id == App.companyData.id
																? true
																: false;
															modalbody +=
																'<tr class="modalrow ' + (isOwn ? 'red' : 'black') + '">'
																+ '<td class="date">' + offers[x].company.name + '</td>'
																+ '<td class="date">' + offers[x].created + '</td>'
																+ '<td class="wide">' + offers[x].amount + '</td>'
																+ '</tr>';
														}
						 								modalbody += '</table>';
													}
													else
													{
														var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no offers!</div>';
													}
													$('#modalbody').html(modalbody);
												}, _w.taskExecError
										);
									}, _w.taskContractError
							);
						});
					},
					style: {
						Make    	: 'make hidden-phone',
						Model    	: 'hidden-phone',
						Type    	: 'type',
						Year   		: 'year',
						KM    		: 'hidden-phone',
						Trade  		: 'hidden-phone',
						Retail    	: 'hidden-phone',
						Offer    	: 'offer',
						Sales    	: 'hidden-phone',
						Manager     : 'hidden-phone',
						Status    	: 'status'


					},
					items: {
						'id'     : row.id,
						'Make'   : row.stock.type.model.make.name,
						'Model'  : row.stock.type.model.name,
						'Type'   : row.stock.type.name,
						'Year'   : row.stock.vehicleYear.name,
						'KM'     : row.stock.km,
						'Trade'  : row.stock.tradePrice,
                        'List'  : row.stock.listPrice,
						'Retail' : 'Dealership Sales' == App.permissions.name
								? row.stock.highestOffer
								: row.stock.retailPrice,
						'Offer'  : 'Dealership Sales' == App.permissions.name
									? row.amountOffered
									: (App.permissions.name == 'Dealership Manager (Used)' || App.permissions.name == 'Dealership Manager (New)'
											? row.amountOffered + '&nbsp;&nbsp;&nbsp;'
											: row.stock.highestOffer + '&nbsp;&nbsp;&nbsp;')
										+ '<a class="soda_pop " id="ofr' + row.id + '"><span>' + row.stock.numberOfOffers + '</span></a>',
						'Sales'  : row.salesProfile.firstName
									? row.salesProfile.firstName + ' ' + row.salesProfile.familyName
									: '',
						'Manager': row.managerProfile.firstName
									? row.managerProfile.firstName + ' ' + row.managerProfile.familyName
									: '',
						'Status' : row.jobState
					}
				});
			}

			_w.valuation.ti.hydrateParam('gridRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'stockPager';
			response.Data.Meta.bind = _w.valuation.pageValuationGrid;
			_w.valuation.ti.hydrateParam('gridPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});

			// todo: add pager hydration
		},

		valuationReport : function()
		{
			window.location.hash = '/valuationreport';
		},

		exportValuationGrid : function()
		{
			App.API.execTask(
					'gridValuation', {}, {'ExportToExcel': true},
					_w.valuation._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		newValuation : function()
		{
			window.location.hash = '/valuationview?id=0';
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
            win.document.write(response);
		},

		clearValuationGridContext : function()
		{
			_w.valuation.gridStatus = 'Inactive';
			try
			{
				$('select.gridValuationFilter').each(function(i, elem) {
					$(elem).val('');
					$(elem).selectpicker('refresh');

				});
			}
			catch(e)
			{
				
			}
			$('.gridValuationContext').val('');
			$('.gridValuationFilter').val('');
			$('#gridValuationContext_notArchived').val('Archived,Stock');

			_w.valuation.dFrom = '';
			_w.valuation.dTo   = '';
			_w.valuation.searchValuationGrid(true);


		},

		searchValuationGrid : function(resetOrder)
		{
			if ($('#gridValuationFilter_Status').val() == 'excludingArchived' ){
				$('#gridValuationContext_notArchived').val('Archived,Stock');
			}
			_w.valuation.gridStatus = 'Inactive';
			var filter = {
					count: 0,
					filters: {


						}
			};
			
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_VIN', 'stock.vinNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_RegNo', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_RefNo', 'stock.referenceNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_Name', 'valuation.familyName');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_DateFrom', 'stock.created', '>=');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_DateTo', 'stock.created', '<=', ' 23:59:59');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationContext_notArchived', 'valuation.jobState', 'NOT IN');
	
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Make', 'make.id');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Year', 'vehicleYear.name');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_KM', 'stock.km');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Trade', 'stock.tradePrice');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Retail', 'stock.retailPrice');
            filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_List', 'stock.listPrice');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Offer', 'stock.highestOffer');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Sales', 'salesProfile.id');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Manager', 'managerProfile.id');
			filter = _w.filterIfnotEmpty(filter, 'gridValuationFilter_Status', 'valuation.jobState');
			
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			if (resetOrder)
			{
				request.Grid.OrderBy = {'stock.created': 'DESC'};
			}
			
			_w.valuation.loadValuationGrid( null, request, {} );
		},

		orderValuationGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.valuation.loadValuationGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}


	};

})();