;(function(){

	window._w.valuationview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,
		limited : false,
		newItem : false,
		validations : 0,
		highestOfferId : false,
		priceGuideId : false,

		onValuationViewTemplateReady : function( template, event, eventData )
		{
			_w.valuationview.itemData = null;
			_w.valuationview.ti = _t[template];
			_w.valuationview.limited = ('limitedvaluationview' == template)
				? true
				: false;

			App.DataStore.setData('departments', [{"value":"New", "label":"New"}, {"value":"Used", "label":"Used"}]);
			App.DataStore.setData('sparekeys', [{"value":"1", "label":"Yes"}, {"value":"0", "label":"No"}]);
			App.DataStore.loadSelectListData('years', true, 'Stock', 'Year.SelectList');
			App.DataStore.loadSelectListData('categories', true, 'Stock', 'Category.SelectList');
			App.DataStore.loadSelectListData('conditions', true, 'Stock', 'Condition.SelectList');
			App.DataStore.loadSelectListData('exteriorColours', true, 'Stock', 'ExteriorColour.SelectList');
			App.DataStore.loadSelectListData('interiorColours', true, 'Stock', 'InteriorColour.SelectList');
			App.DataStore.loadSelectListData('upholsteries', true, 'Stock', 'Upholstery.SelectList');
			App.DataStore.loadSelectListData('papers', true, 'Stock', 'Paper.SelectList');
			App.DataStore.loadSelectListData('natis', true, 'Stock', 'Natis.SelectList');
			App.DataStore.loadSelectListData('fsh', true, 'Stock', 'FullServiceHistory.SelectList');
			App.DataStore.loadSelectListData('fuelTypes', true, 'Stock', 'FuelType.SelectList');
			App.DataStore.loadSelectListData('transmissionTypes', true, 'Stock', 'TransmissionType.SelectList');
			App.DataStore.loadSelectListData('damages', true, 'Stock', 'Damage.SelectList');
			App.DataStore.loadSelectListData('accessories', true, 'Stock', 'Accessory.SelectList');
			App.DataStore.loadSelectListData('clubs', true, 'PriceGuide', 'Club.SelectList');
			App.DataStore.loadSelectListData('valuators', true, 'User', 'Profile.ValuatorList');
			App.DataStore.loadSelectListData('sales', true, 'User', 'Profile.SalesList');



			_w.valuationview.setValuationViewFormMeta();
			_w.valuationview.ti.hydrate(_w.valuationview.formMeta);
			// Retrieve initial view data.
			_w.valuationview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.valuationview.itemId || null == _w.valuationview.itemId)
			{
				_w.valuationview.newItem = true;
				_w.valuationview.itemData = {stock:{}};
				App.API.getTask(
					'createValuationNew', 'Valuation', 'Valuation.CreateNew',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createValuationPending', 'Valuation', 'Valuation.CreatePending',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createValuationComplete', 'Valuation', 'Valuation.CreateComplete',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createValuationPriceGuide', 'Valuation', 'Valuation.CreatePriceGuide',
					null, {}, function(){}, _w.taskContractError
				);
				App.API.getTask(
					'createValuationStock', 'Valuation', 'Valuation.CreateStock',
					null, {}, function(){}, _w.taskContractError
				);

			}
			else
			{
				_w.valuationview.newItem = false;
				var task = _w.valuationview.limited
					? 'Valuation.LimitedUpdate'
					: 'Valuation.Update';
				App.API.getTask(
					'updateValuation:' + _w.valuationview.itemId, 'Valuation', task, _w.valuationview.itemId,
					{}, $.proxy( _w.valuationview._onValuationViewDataReceived, this ), _w.taskContractError
				);
			}

		},

		onValuationViewPublished : function( template, event, eventData )
		{
			_w.valuationview.limited = ('limitedvaluationview' == template)
				? true
				: false;

			if (_w.valuationview.newItem)
			{
				_w.valuationview._setupValidation();
				$('#btnSaveAsSales').show();
				$('#btnSaveAsPending').show();
				$('#optSendToSales').show();
				$('#optSendToPg').show();
				$('#btnSendToStock').show();
				$('#btnUpdate').prop('disabled', false);
				$('#printValuationPdf').hide();


				/*
				 * Permissions
				 */
				true == App.permissions.valuationCreateSales ? $('#sectionSelectValuator').show() : $('#sectionSelectValuator').hide();
				true == App.permissions.valuationCreatePriceguide ? $('#optSendToPg').show() : $('#optSendToPg').hide();
				true == App.permissions.valuationCreateComplete ? $('#optSendToSales').show() : $('#optSendToSales').hide();
				true == App.permissions.valuationCreateNew ? $('#btnUpdate').show() : $('#btnUpdate').hide();
				true == App.permissions.valuationCreateStock ? $('#btnSendToStock').show() : $('#btnSendToStock').hide();
				true == App.permissions.valuationCreatePending ? $('#btnSaveAsPending').show() : $('#btnSaveAsPending').hide();

				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_overAllowance').show() : $('#' + _w.valuationview.ti.tid  + '_overAllowance').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_standInValue').show() : $('#' + _w.valuationview.ti.tid  + '_standInValue').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_projectedRetail').show() : $('#' + _w.valuationview.ti.tid  + '_projectedRetail').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_plannedMargin').show() : $('#' + _w.valuationview.ti.tid  + '_plannedMargin').hide();

				if (!App.permissions.valuationUpdateDamages)
				{
					$('.damages-form').hide();
				}
				if (!App.permissions.valuationUploadPhotos)
				{
					$('.photos-form').hide();
				}
			}
			$('#btnUpdate').prop('disabled', true);
			$('#btnFetchTu').click(function () {
				if (!$('#vehicleYear').val()
					|| !$('#vehicleType').val())
				{
					alert('Vehicle year and type is required to fetch Trade and Retail pricing.');
					return;
				}
				$('#btnFetchTu').prop('disabled', true);
				App.API.getTask(
						'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
						{}, _w.valuationview._onTuReady, _w.taskContractError
				);
			});
			$('#doAcceptOffer').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				/*
				highestOfferId : false,
				priceGuideId : false, */
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToDealDone').prop('disabled', true);
				$('#btnSendToDealNotDone').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
					'updateValuation:' + _w.valuationview.itemId, data, {},
					function() {
						App.API.getRoute(
								'offerAcceptedOnValuation:' + _w.valuationview.priceGuideId, 'PriceGuide', 'Offer.AcceptOffer', _w.valuationview.priceGuideId,
								{id: _w.valuationview.highestOfferId}, function() {
									App.API.execRoute(
											'offerAcceptedOnValuation:' + _w.valuationview.priceGuideId, {}, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
									);
								}, _w.taskContractError
						);
					}, _w.taskExecError
				);

			});
			$('#btnSendToDealNotDone').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToDealDone').prop('disabled', true);
				$('#btnSendToDealNotDone').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
					'updateValuation:' + _w.valuationview.itemId, data, {},
					function() {
						App.API.directRoute(
								'dealnotdoneonValuation:' + _w.valuationview.itemId,
								'Valuation', 'Valuation.MoveToDealNotDone', _w.valuationview.itemId, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
						);
					}, _w.taskExecError
				);

			});
			$('#btnArchive').click(function () {
				App.API.directRoute(
						'archiveValuation:' + _w.valuationview.itemId,
						'Valuation', 'Valuation.MoveToArchive', _w.valuationview.itemId, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
				);
			});
			$('#btnUnarchive').click(function () {
				App.API.directRoute(
						'unarchiveValuation:' + _w.valuationview.itemId,
						'Valuation', 'Valuation.UnArchive', _w.valuationview.itemId, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
				);
			});
			$('#btnSaveAsPending').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					var data = _w.valuationview._prepValuationUpdateData();
					App.API.execTask(
						'createValuationPending', data, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}
				else
				{
					_w.valuationview._routeToPending();
				}
			});
			$('#btnSaveAsSales').click(function () {
				var valuators = $('#valuators').val();
				if (null == valuators)
				{
					alert('Please select at least one valuator.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					var data = _w.valuationview._prepValuationUpdateData();
					var valuators = $('#valuators').val();
					data.Valuation.valuators = [];
					for (var i = 0; i < valuators.length; i++)
					{
						data.Valuation.valuators.push({id: valuators[i]});
					}
					App.API.execTask(
						'createValuationNew', data, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}
				else
				{
					var data = _w.valuationview._prepValuationUpdateData();
					var valuators = $('#valuators').val();
					data.Valuation.valuators = [];
					for (var i = 0; i < valuators.length; i++)
					{
						data.Valuation.valuators.push({id: valuators[i]});
					}
					App.API.execTask(
						'updateValuation:' + _w.valuationview.itemId, data, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}
			});
			$('#btnSendToSales').click(function () {
				var profile = $('#salesProfile').val();
				var amount  = $('#salesAmountOffered').val();
				if (null == profile || '' == amount)
				{
					alert('Please select Sales person and enter an Amount.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					var data = _w.valuationview._prepValuationUpdateData();
					data.Valuation.amountOffered = amount;
					App.API.execTask(
							'createValuationComplete', data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
						);
				}
				else
				{
					if ('Price Guide' == _w.valuationview.itemData.jobState)
					{
						App.API.getTask(
								'sendToSalesFull:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToSalesFull', _w.valuationview.itemId,
								{}, function() {
									var data = _w.valuationview._prepValuationUpdateData();
									data.Valuation.amountOffered = $('#salesAmountOffered').val();
									App.API.execTask(
											'sendToSalesFull:' + _w.valuationview.itemId, data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
										);
								}, _w.taskContractError
							);
					}
					else
					{
						_w.valuationview._routeToComplete();
					}
				}
			});
			$('#doSendToStock').click(function () {
				var stockNo = $('#stockNumber').val();
				if (null == stockNo || '' == stockNo)
				{
					alert('Please enter a stock number.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					var data = _w.valuationview._prepValuationUpdateData();
					App.API.execTask(
						'createValuationStock', data, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}
				else
				{
					_w.valuationview._routeToStock();
				}
			});
			$('#btnSendToPg').click(function () {
				var clubs = $('#clubs').val();
				if (null == clubs)
				{
					alert('Please select at least one club.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					var data = _w.valuationview._prepValuationUpdateData();
					data.Context = {clubs:[]};
					var clubList = $('#clubs').val();
					for (var i = 0; i < clubList.length; i++)
					{
						data.Context.clubs.push({id: clubList[i]});
					}
					App.API.execTask(
						'createValuationPriceGuide', data, {},
						_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}
				else
				{
					_w.valuationview._routeToPg();
				}
			});

			$('.back-btn').on('click', function(){
				window.history.back();
			});

			if (!_w.valuationview.newItem && null != _w.valuationview.itemData)
			{
				_w.valuationview._onDataAndTemplate();
			}
		},

		_routeToPg : function()
		{
			App.API.getRoute(
				'sendToPg:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToPriceGuide', _w.valuationview.itemId,
				{}, function() {
					var data = _w.valuationview._prepValuationUpdateData();
					data.Context = {clubs:[]};
					var clubList = $('#clubs').val();
					for (var i = 0; i < clubList.length; i++)
					{
						data.Context.clubs.push({id: clubList[i]});
					}
					App.API.execRoute(
							'sendToPg:' + _w.valuationview.itemId, data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}, _w.taskContractError
			);
		},

		_routeToPending : function()
		{
			App.API.getRoute(
				'sendToPending:' + _w.valuationview.itemId, 'Valuation', 'Valuation.MoveToPending', _w.valuationview.itemId,
				{}, function() {
					var data = _w.valuationview._prepValuationUpdateData();
					App.API.execRoute(
							'sendToPending:' + _w.valuationview.itemId, data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}, _w.taskContractError
			);
		},

		_routeToComplete : function()
		{
			App.API.getRoute(
				'sendToComplete:' + _w.valuationview.itemId, 'Valuation', 'Valuation.MoveToComplete', _w.valuationview.itemId,
				{}, function() {
					var data = _w.valuationview._prepValuationUpdateData();
					data.Valuation.amountOffered = $('#salesAmountOffered').val();
					App.API.execRoute(
							'sendToComplete:' + _w.valuationview.itemId, data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}, _w.taskContractError
			);
		},

		_routeToStock : function()
		{
			App.API.getRoute(
				'sendToStock:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToStock', _w.valuationview.itemId,
				{}, function() {
					var data = _w.valuationview._prepValuationUpdateData();
					App.API.execRoute(
							'sendToStock:' + _w.valuationview.itemId, data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
					);
				}, _w.taskContractError
			);
		},




		setValuationViewFormMeta : function( data )
		{

			var damages = {};

			if (undefined != data && undefined != data.stock)
			{
				for (var i = 0; i < data.stock.damages.length; i++)
				{
					damages['d' + data.stock.damages[i].damage] = data.stock.damages[i].amount;
				}
			}
			else
			{
				data = {"stock":{}};
			}

				_w.valuationview.formMeta = {
				'vehicleYear' : {
					type        : 'select',
					id          : 'vehicleYear',
					title       : 'Year',
					dataStoreId : 'years',
					value       : data.stock.vehicleYear ? data.stock.vehicleYear : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleYear', false))
						{
							_w.valuationview._listMakesModelsTypes(false, function () {
								if ($('#vehicleYear').val() && $('#vehicleType').val())
								{
									App.API.getTask(
											'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
											{}, _w.valuationview._onTuReady, _w.taskContractError
									);
								}
							});
						}
					}
				},
				'category' : {
					type        : 'select',
					id          : 'vehicleCategory',
					title       : 'Category',
					dataStoreId : 'categories',
					value       : data.stock.type ? data.stock.type.category.id : '',
					onChange    : function () {
						
						
						if ($(this).val() == 8 && _w.valuationview.itemId == 0) {
							// show the hidden input fields
							$("#manualVehicle").show();
							$("#selectionVehicle").hide();
							$('#mmCode').html("Other");
						}
						if ($(this).val() != 8 && _w.valuationview.itemId != 0) {
							// show the hidden input fields
							$("#manualVehicle").hide();
							$("#selectionVehicle").show();
							$('#mmCode').html("");
						}
						
						if (!App.DataStore.getItem('BuildSelect:vehicleCategory', false) && $(this).val() != 8)
						{
							_w.valuationview._listMakesModelsTypes();
						}
					}
				},
				'make' : {
					type        : 'select',
					id          : 'vehicleMake',
					title       : 'Vehicle Make',
					dataStoreId : 'makes',
					value       : data.stock.type ? data.stock.type.model.make.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleMake', false))
						{
							_w.valuationview._listMakesModelsTypes();
						}
					}
				},
				'model' : {
					type        : 'select',
					id          : 'vehicleModel',
					title       : 'Vehicle Model',
					dataStoreId : 'models',
					value       : data.stock.type ? data.stock.type.model.id : '',
					onChange    : function () {
						if (!App.DataStore.getItem('BuildSelect:vehicleModel', false))
						{
							_w.valuationview._listMakesModelsTypes();
						}
					}
				},
				'type' : {
					type        : 'select',
					id          : 'vehicleType',
					title       : 'Vehicle Type',
					dataStoreId : 'types',
					value       : data.stock.type ? data.stock.type.id : '',
					onChange    : function () {
						if ('' != $(this).val() && null != $(this).val())
						{
							App.API.getTask(
									'GetMmCode' + $(this).val(), 'Stock', 'Type.GetMmCode', null,
									{id:$(this).val()}, function(response){
										$('#mmCode').html(response.Data.mmCode);
									}, _w.taskContractError
							);
						}
						else
						{
							$('#mmCode').html('');
						}
						if (!App.DataStore.getItem('BuildSelect:vehicleType', false)
							&& $('#vehicleYear').val()
							&& $('#vehicleType').val())
						{
							$('#btnFetchTu').prop('disabled', true);
							App.API.getTask(
									'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
									{}, _w.valuationview._onTuReady, _w.taskContractError
							);
						}
					}
				},
				
				
				'makeManual' : {
					type        : 'input',
					id          : 'vehicleMakeManual',
					title       : 'Vehicle Make',
					//dataStoreId : 'makes',
					value       : data.stock.type ? data.stock.type.model.make.id : '',
					
				},
				'modelManual' : {
					type        : 'input',
					id          : 'vehicleModelManual',
					title       : 'Vehicle Model',
					//dataStoreId : 'models',
					value       : data.stock.type ? data.stock.type.model.id : '',
					
				},
				'typeManual' : {
					type        : 'input',
					id          : 'vehicleTypeManual',
					title       : 'Vehicle Type',
					//dataStoreId : 'types',
					value       : data.stock.type ? data.stock.type.id : '',
				
				},
				
				
				
				'mmCode' : {
					type        : 'input',
					id          : 'mmCode',
					title       : 'MM Code',
					style		: 'disable',
					setAttrib	: 'readonly',
					value       : data.stock.type ? data.stock.type.mmCode : ''
				},
				'fuelType' : {
					type        : 'select',
					id          : 'vehicleFuelType',
					title       : 'Fuel Type',
					dataStoreId : 'fuelTypes',
					value       : data.stock.fuelType ? data.stock.fuelType : ''
				},
				'transmissionType' : {
					type        : 'select',
					id          : 'vehicleTransmissionType',
					title       : 'Transmission Type',
					dataStoreId : 'transmissionTypes',
					value       : data.stock.transmissionType ? data.stock.transmissionType : ''
				},
				'registrationNumber' : {
					type  : 'input',
					id    : 'registrationNumber',
					title : 'Registration no',
					value : data.stock.registrationNumber ? data.stock.registrationNumber : ''
				},
				'vinNumber' : {
					type  : 'input',
					id    : 'vinNumber',
					title : 'Vin no',
					value : data.stock.vinNumber ? data.stock.vinNumber : ''
				},
				'engineNumber' : {
					type  : 'input',
					id    : 'engineNumber',
					title : 'Eng. no',
					value : data.stock.engineNumber ? data.stock.engineNumber : ''
				},
				'km' : {
					type  : 'input',
					id    : 'km',
					title : 'Kms',
					value : data.stock.km ? data.stock.km : ''
				},
				'condition' : {
					type        : 'select',
					id          : 'vehicleCondition',
					title       : 'Condition',
					dataStoreId : 'conditions',
					value       : data.stock.condition ? data.stock.condition : ''
				},
				'exteriorColour' : {
					type        : 'select',
					id          : 'exteriorColour',
					title       : 'Main ext. colour',
					dataStoreId : 'exteriorColours',
					value       : data.stock.exteriorColour ? data.stock.exteriorColour : ''
				},
				'interiorColour' : {
					type  : 'select',
					id    : 'interiorColour',
					title : 'Main int. colour',
					dataStoreId : 'interiorColours',
					value : data.stock.interiorColour ? data.stock.interiorColour : ''
				},
				'upholstery' : {
					type        : 'select',
					id          : 'vehicleUpholstery',
					title       : 'Upholstery',
					dataStoreId : 'upholsteries',
					value       : data.stock.upholstery ? data.stock.upholstery : ''
				},
				'papers' : {
					type        : 'select',
					id          : 'vehiclePapers',
					title       : 'Papers',
					dataStoreId : 'papers',
					value       : data.stock.papers ? data.stock.papers : ''
				},
				'natis' : {
					type        : 'select',
					id          : 'vehicleNatis',
					title       : 'Natis',
					dataStoreId : 'natis',
					value       : data.stock.natis ? data.stock.natis : ''
				},
				'spareKeys' : {
					type        : 'select',
					id          : 'spareKeys',
					title       : 'Spare keys',
					dataStoreId : 'sparekeys',
					value       : undefined != data.stock.spareKeys && null != data.stock.spareKeys
									? (data.stock.spareKeys == true ? "1" : "0")
									: null
				},
				'fullServiceHistory' : {
					type        : 'select',
					id          : 'fullServiceHistory',
					title       : 'Full service history',
					dataStoreId : 'fsh',
					value       : data.stock.fullServiceHistory ? data.stock.fullServiceHistory : ''
				},
				'fshNotes' : {
					type  : 'textarea-small',
					id    : 'fshNotes',
					title : 'FSH notes',
					value : data.stock.fshNotes ? data.stock.fshNotes : ''
				},
				'damages' : {
					type        : 'damageDetails',
					disabled	: !App.permissions.valuationUpdateDamages,
					id          : 'damages',
					dataStoreId : 'damages',
					data        : data.stock.damages ? data.stock.damages : {}
				},
				'damageTotal' : 'R 0.00',
				'damageNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.valuationUpdateDamages,
					id    : 'damageNotes',
					title : 'Damages comments',
					style : 'damages-comments',
					value : data.stock.damageNotes ? data.stock.damageNotes : ''
				},

				'previousRepairsNoted' : {
					type  : 'checkbox',
					id    : 'previousRepairsNoted',
					title : 'Previous repairs',
					style : 'damages-comments',
					value : data.stock.previousRepairsNoted ? data.stock.previousRepairsNoted : false
				},
				'previousRepairsNotes' : {
					type  : 'textarea-styled',
					disabled	: !App.permissions.valuationUpdateDamages,
					id    : 'previousRepairsNotes',
					title : 'Previous repairs notes',
					style : 'damages-comments',
					value : data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : '',
					onChange: function(){
						var haveData = ('' != $(this).val() ? true : false);
						$('#previousRepairsNoted').prop('checked', haveData);
					}
				},
				'accessories' : {
					type        : 'checkGroup',
					id          : 'accessories',
					dataStoreId : 'accessories',
					itemName    : 'accessory',
					data        : data.stock.accessories ? data.stock.accessories : {}
				},
				'accessoryNotes' : {
					type      : 'textarea-styled',
					id        : 'accessoryNotes',
					title     : 'Comments',
					style     : 'comment mobile-comment',
					areaStyle : 'comment-text-box',
					value     : data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
				},
				'mainImage' : {
					type  : 'image',
					id    : 'mainImage',
					baseImage : 'main_img_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.mainImage ? data.stock.mainImage : ''
				},
				'frontImage' : {
					type  : 'image',
					id    : 'frontImage',
					baseImage : 'front_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.frontImage ? data.stock.frontImage : ''
				},
				'leftImage' : {
					type  : 'image',
					id    : 'leftImage',
					baseImage : 'left_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.leftImage ? data.stock.leftImage : ''
				},
				'rightImage' : {
					type  : 'image',
					id    : 'rightImage',
					baseImage : 'right_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.rightImage ? data.stock.rightImage : ''
				},
				'backImage' : {
					type  : 'image',
					id    : 'backImage',
					baseImage : 'back_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.backImage ? data.stock.backImage : ''
				},
				'interiorImage' : {
					type  : 'image',
					id    : 'interiorImage',
					baseImage : 'interior_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.interiorImage ? data.stock.interiorImage : ''
				},
				'engineImage' : {
					type  : 'image',
					id    : 'engineImage',
					baseImage : 'engine_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.engineImage ? data.stock.engineImage : ''
				},
				'natisImage' : {
					type  : 'image',
					id    : 'natisImage',
					baseImage : 'copy_of_natis_car.jpg',
					view  : !App.permissions.valuationUploadPhotos,
					value : data.stock.natisImage ? data.stock.natisImage : ''
				},
				'clubs' : {
					type        : 'select',
					id          : 'clubs',
					title       : 'Select clubs',
					dataStoreId : 'clubs',
					multiple    : true,
					value       : ''
				},
				'print': {
					constructor: 'Button',
					items: ('New Valuation' == data.jobState
							&& 'Dealership Valuator' != App.permissions.name
							&& 'Dealership Sales' != App.permissions.name)
					? {
						Export: {
							preset: 'Print',
							id: 'printValuationPdf',
							handler: _w.valuationview.printValuationPdf
						},
						ExportTC: {
							preset: 'PrintTC',
							id: 'printValuationPdfTC',
							handler: _w.valuationview.printValuationPdfTC
						}
					}
					: {
						Export: {
							preset: 'Print',
							id: 'printValuationPdf',
							handler: _w.valuationview.printValuationPdf
						}
					}
				},

				'infCreated': data.created ? ((data.created).split(' '))[0] : '',
				'infValuationNumber': data.valuationNumber ? data.valuationNumber : '',
				'infReferenceNumber': data.stock.referenceNumber ? data.stock.referenceNumber : '',
				'infStatus': data.jobState ? data.jobState : '',
				'infCreatedBy': data.createdBy && data.createdBy.firstName
					? data.createdBy.firstName + ' ' +  data.createdBy.familyName
					: '',
				'infValuator': data.valuatedBy && data.valuatedBy.firstName
					? data.valuatedBy.firstName + ' ' +  data.valuatedBy.familyName
					: '',
				'infSalesUser': data.salesProfile && data.salesProfile.firstName
					? data.salesProfile.firstName + ' ' +  data.salesProfile.familyName
					: '',
				'infLoadedOnPriceGuide': data.stock.loadedOnPriceGuide
					? ((data.stock.loadedOnPriceGuide).split(' '))[0] : '',
				'infTradePrice': data.stock.tradePrice ? 'R ' + data.stock.tradePrice : '0.00',
				'infRetailPrice': data.stock.retailPrice ? 'R ' + data.stock.retailPrice : '0.00',
				'firstName' : {
					type  : 'input',
					id    : 'firstName',
					title : 'Customer name',
					value : data.firstName ? data.firstName : ''
				},
				'familyName' : {
					type  : 'input',
					id    : 'familyName',
					title : 'Customer surname',
					value : data.familyName ? data.familyName : ''
				},
				'idNumber' : {
					type  : 'input',
					id    : 'idNumber',
					title : 'ID',
					value : data.idNumber ? data.idNumber : ''
				},
				'mobile' : {
					type  : 'mobile',
					id    : 'mobile',
					title : 'Mobile',
					value : data.mobile ? data.mobile : ''
				},
				'email' : {
					type  : 'input',
					id    : 'email',
					title : 'Email',
					value : data.email ? data.email : ''
				},
				'department' : {
					type        : 'select',
					id          : 'department',
					title       : 'Department',
					dataStoreId : 'departments',
					value       : data.department ? data.department : ''
				},

				'amountOffered' : {
					type  : 'input',
					disabled  : true,
					style : 'rand-input',
					id    : 'amountOffered',
					title : 'Amount offered',
					value : data.amountOffered ? data.amountOffered : '0.00'
				},
				'overAllowance' : {
					type  : 'input',
					style : 'rand-input',
					id    : 'overAllowance',
					title : 'O.A',
					value : data.overAllowance ? data.overAllowance : '0.00'
				},
				'standInValue' : {
					type  : 'input',
					style : 'rand-input',
					id    : 'standInValue',
					title : 'Stand-in-value',
					value : data.standInValue ? data.standInValue : '0.00'
				},
				'projectedRetail' : {
					type  : 'input',
					style : 'rand-input',
					id    : 'projectedRetail',
					title : 'Projected retail',
					value : data.projectedRetail ? data.projectedRetail : '0.00'
				},
				'plannedMargin' : {
					type  : 'input',
					style : 'rand-input',
					id    : 'plannedMargin',
					title : 'Planned margin',
					value : data.plannedMargin ? data.plannedMargin : '0.00'
				},
				'valuators' : {
					type        : 'select',
					id          : 'valuators',
					title       : 'Select valuator',
					dataStoreId : 'valuators',
					multiple    : true,
					value       : data.valuators ? data.valuators : []
				},
				'salesProfile' : {
					type        : 'select',
					id          : 'salesProfile',
					title       : 'Sales person',
					dataStoreId : 'sales',
					value       : ''
				},
				'salesAmountOffered' : {
					type  : 'input',
					style : 'rand-inputs',
					id    : 'salesAmountOffered',
					title : 'Amount',
					value : data.amountOffered ? data.amountOffered : '0.00',
					onFocus : function()
						{
							var $_this = $(this),
									value  = $_this.val();

							if( value == '0.00' )
								{
									$_this.val('');
								}
						},
					onBlur : function()
						{
							var $_this = $(this),
									value  = $_this.val();

							if( value === '' )
								{
									$_this.val('0.00');
								}
						}
				},
				'salesComments' : {
					type      : 'textarea-styled',
					id        : 'salesComments',
					title     : 'Comments',
					style     : 'comment',
					areaStyle : 'comment-text-box',
					value     : data.salesComments ? data.salesComments : ''
				},
				'stockNumber' : {
					type  : 'input',
					id    : 'stockNumber',
					title : 'Stock number',
					value : data.stock.stockNumber ? data.stock.stockNumber : ''
				}
			};
		},

		printValuationPdf : function()
		{
			var task = 'Pdf.Print003';
			if ('New Valuation' == _w.valuationview.itemData.jobState
					&& ('Dealership Valuator' == App.permissions.name
							|| 'Dealership Sales' == App.permissions.name))
			{
				// T&C version
				var task = 'Pdf.Print001';
			}
			else if ('Dealership Valuator' == App.permissions.name
					|| 'Dealership Sales' == App.permissions.name)
			{
				var task = 'Pdf.Print002';
			}
			App.API.getTask(
					'printValuation:' + _w.valuationview.itemData.stock.id,
					'Valuation', task, _w.valuationview.itemId,
					{}, function() {
						App.API.execTask(
								'printValuation:' + _w.valuationview.itemData.stock.id, {}, {},
								_w.valuationview._onExportReceived, _w.taskExecError,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},

		printValuationPdfTC : function()
		{
			// Consider the T&C requirement.
			var task = 'Pdf.Print001';
			App.API.getTask(
					'printValuation:' + _w.valuationview.itemData.stock.id,
					'Valuation', task, _w.valuationview.itemId,
					{}, function() {
						App.API.execTask(
								'printValuation:' + _w.valuationview.itemData.stock.id, {}, {},
								_w.valuationview._onExportReceived, _w.taskExecError,
								'EXPORT', true
						);
					}, _w.taskContractError
			);
		},

		_listMakesModelsTypes : function( fromItemData, callback )
		{
			if (fromItemData)
			{
				var year     = _w.valuationview.itemData.stock.vehicleYear;
				var category = _w.valuationview.itemData.stock.type.category.id;
				var make     = _w.valuationview.itemData.stock.type.model.make.id;
				var model    = _w.valuationview.itemData.stock.type.model.id;
				var type   = _w.valuationview.itemData.stock.type.id;
				var mmcode   = _w.valuationview.itemData.stock.type.mmcode;
			}
			else
			{
				var year     = $('#vehicleYear').val();
				var category = $('#vehicleCategory').val();
				var make     = $('#vehicleMake').val();
				var model    = $('#vehicleModel').val();
				var type     = $('#vehicleType').val();
				var mmcode   = $('#mmCode').val();
			}
			if (year && category)
			{
				App.DataStore.loadSelectListData(
						'makes', false, 'Stock', 'Utility.ListMakes', null,
						{"Filter": {
							"category" : category,
							"year" : year
							}}
						);
			}
			if (make && year && category)
			{
				App.DataStore.loadSelectListData(
						'models', false, 'Stock', 'Utility.ListModels', null,
						{"Filter": {
							"make" : make,
							"category" : category,
							"year" : year
							}}
						);
			}
			if (model && year && category)
			{
				App.DataStore.loadSelectListData(
						'types', false, 'Stock', 'Utility.ListTypes', null,
						{"Filter": {
							"model" : model,
							"category" : category,
							"year" : year
							}}, {}, callback
						);
			}
		},

		_onDataAndTemplate : function()
		{
			var total = 0.00;
			$.each($.find('.damage-input'), function(i, input) {
				total += parseFloat($(input).val());
			});
			$('#' + _w.valuationview.ti.tid + '_damageTotal').html('R ' + total);
			$('#doAcceptOffer').prop('disabled', true);
			if (null != _w.valuationview.itemData.stock.priceGuide
					&& 0 < _w.valuationview.itemData.stock.highestOffer)
			{
				_w.valuationview.priceGuideId = _w.valuationview.itemData.stock.priceGuide;
				App.API.getTask(
						'offerList', 'PriceGuide', 'Offer.List',
						_w.valuationview.itemData.stock.priceGuide, {}, function(){
							App.API.execTask(
									'offerList', {}, {},
									function(response)
									{
										var offers = response.Data;
										if (offers.length)
										{
											var highest = 0;
											var lowestDate = 0;
											var highestId = 0;
											var valid = 0;
											for (var x in offers)
											{
												if ('Valid Offer' != offers[x].status)
												{
													continue;
												}
												valid++;
												var dateInt = parseInt(
														offers[x].created.split(' ')[0].split('-').join('')
														+ offers[x].created.split(' ')[1].split(':').join('')
														);
												if  ( (parseInt(offers[x].amount) == highest && dateInt < lowestDate)
														|| parseInt(offers[x].amount) > highest)
												{
													highest = parseInt(offers[x].amount);
													highestId = x;
													lowestDate = dateInt;
												}
											}
											if (0 == valid)
											{
												var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no valid offers!</div>';
												$('#dealDoneOfferList').html(modalbody);
												return;
											}
											_w.valuationview.highestOfferId = highestId;
											var modalbody = '<table class="table table-bordered table-condensed table-striped">';
											modalbody += '<tr class="table-header-red"><td>Company</td><td>Date Offered</td><td>Amount</td></tr>';
											for (var x in offers)
											{
												if ('Valid Offer' != offers[x].status)
												{
													continue;
												}
												var isOwn = highestId == x
													? true
													: false;
												modalbody +=
													'<tr class="modalrow ' + (isOwn ? 'red' : 'black') + '">'
													+ '<td class="date">' + offers[x].company.name + '</td>'
													+ '<td class="date">' + offers[x].created.split(' ')[0] + '</td>'
													+ '<td class="wide">R' + offers[x].amount.split('.')[0] + '</td>'
													+ '</tr>';
											}
			 								modalbody += '</table>';
											$('#doAcceptOffer').prop('disabled', false);
										}
										else
										{
											var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no valid offers!</div>';
										}
										$('#dealDoneOfferList').html(modalbody);
									}, _w.taskExecError
							);
						}, _w.taskContractError
				);
			}

			if (_w.valuationview.limited)
			{
				$('input').prop('disabled', true);
				$('button').prop('disabled', true);
				$('checkbox').prop('disabled', true);
				$('textarea').prop('disabled', true);
				$('#btnUnarchive').prop('disabled', false);
				$('#printValuationPdf').prop('disabled', false);
				$('#optSendToSales').prop('disabled', false);
				$('#salesProfile').prop('disabled', false);
				$('button[data-id="salesProfile"]').prop('disabled', false);
				$('#salesAmountOffered').prop('disabled', false);
				$('#salesComments').prop('disabled', false);
				$('#btnSendToSales').prop('disabled', false);
				$('#printValuationPdf').prop('disabled', false);
				
				// Mobi buttons
				$('#mobiAuctionBtn').prop('disabled', false);
				$('#mobiPriceGuideBtn').prop('disabled', false);
				$('#mobiValuationsBtn').prop('disabled', false);
			}
			$('#sectionSelectValuator').hide();
			if (!_w.valuationview.newItem)
			{
				$('#retailPrice').val(_w.valuationview.itemData.stock.retailPrice);
				$('#tradePrice').val(_w.valuationview.itemData.stock.tradePrice);
				switch (_w.valuationview.itemData.jobState)
				{
				case 'New Valuation':
					$('#btnSaveAsSales').show();
					$('#btnSaveAsPending').show();
					$('#optSendToPg').show();
					$('#btnSendToStock').show();
					$('#btnArchive').show();
					true == App.permissions.valuationCreateSales
							? $('#sectionSelectValuator').show()
							: $('#sectionSelectValuator').hide();
					if (!App.permissions.valuationUpdateDamages)
					{
						$('.damages-form').hide();
					}
					if (!App.permissions.valuationUploadPhotos)
					{
						$('.photos-form').hide();
					}
					break;
				case 'Pending Valuation':
					$('#optSendToSales').show();
					$('#optSendToPg').show();
					$('#btnSendToStock').show();
					$('#btnArchive').show();
					if (null != _w.valuationview.itemData.stock.priceGuide
							&& 0 < _w.valuationview.itemData.stock.highestOffer)
					{
						$('#btnSendToDealDone').show();
						$('#btnSendToDealNotDone').show();
					}
					if (!App.permissions.valuationUpdateDamages)
					{
						$('.damages-form').hide();
					}
					if (!App.permissions.valuationUploadPhotos)
					{
						$('.photos-form').hide();
					}
					break;
				case 'Complete Valuation':
					$('#optSendToSales').show();
					$('#optSendToPg').show();
					$('#btnSendToStock').show();
					$('#btnArchive').show();
					if (null != _w.valuationview.itemData.stock.priceGuide
							&& 0 < _w.valuationview.itemData.stock.highestOffer)
					{
						$('#btnSendToDealDone').show();
						$('#btnSendToDealNotDone').show();
					}
					break;
				case 'Offer Accepted':
					$('#btnSendToStock').show();
					$('#btnSendToStock').prop('disabled', false);
					$('#stockNumber').prop('disabled', false);
					$('#doSendToStock').prop('disabled', false);
					$('#btnArchive').show();
					$('#btnArchive').prop('disabled', false);
					break;
				case 'Deal Done':
					$('#btnSendToStock').show();
					$('#btnSendToStock').prop('disabled', false);
					$('#stockNumber').prop('disabled', false);
					$('#doSendToStock').prop('disabled', false);
					$('#btnArchive').show();
					$('#btnArchive').prop('disabled', false);
					break;
				case 'Deal Not Done':
					$('#btnSaveAsPending').show();
					$('#optSendToPg').show();
					$('#btnSendToStock').show();
					$('#btnArchive').show();
					break;
				case 'Archived':
					$('#btnUnarchive').show();
					break;
				case 'Price Guide':
					$('#optSendToSales').show();
					break;
				}
			}

			/*
			 * Permissions
			 */
			$('#optSendToPg').prop('disabled', true == App.permissions.valuationRoutePriceguide ? false : true);
			$('#optSendToSales').prop('disabled', true == App.permissions.valuationRouteComplete ? false : true);
			$('#btnUpdate').prop('disabled', true == App.permissions.valuationUpdate ? false : true);
			$('#btnSendToStock').prop('disabled', true == App.permissions.valuationRouteStock ? false : true);
			$('#btnSaveAsPending').prop('disabled', true == App.permissions.valuationRoutePending ? false : true);
			$('#btnSendToDealDone').prop('disabled', true == App.permissions.valuationRouteDealDone ? false : true);
			$('#btnSendToDealNotDone').prop('disabled', true == App.permissions.valuationRouteDealNotDone ? false : true);
			if ('Dealership Sales' == App.permissions.name && !_w.valuationview.newItem)
			{
				$('#btnSaveAsPending').hide();
			}

			$('#btnArchive').prop('disabled', true == App.permissions.valuationArchive ? false : true);
			$('#printValuationPdf').prop('disabled', true == App.permissions.valuationPrint ? false : true);
			$('#btnB4cAccidentReport').prop('disabled', true == App.permissions.valuationB4cReport ? false : true);
			$('#btnBwmAccidentReport').prop('disabled', true == App.permissions.valuationBmw ? false : true);



			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_overAllowance').show() : $('#' + _w.valuationview.ti.tid  + '_overAllowance').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_standInValue').show() : $('#' + _w.valuationview.ti.tid  + '_standInValue').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_projectedRetail').show() : $('#' + _w.valuationview.ti.tid  + '_projectedRetail').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid  + '_plannedMargin').show() : $('#' + _w.valuationview.ti.tid  + '_plannedMargin').hide();


			_w.valuationview._setupValidation();
		},

		_onValuationViewDataReceived : function( response )
		{
			_w.valuationview.itemId = response.Data.id;
			_w.valuationview.itemData = response.Data;
			_w.valuationview._listMakesModelsTypes(true);
			_w.valuationview.setValuationViewFormMeta(response.Data);
			_w.valuationview.ti.hydrate(_w.valuationview.formMeta);
			if (_w.valuationview.ti.published)
			{
				_w.valuationview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			App.DataStore.listen('regValidation', 'damages', function(id, damages) {
				var rules = {
					firstName: {required: true, minlength: 3},
					familyName: {required: true, minlength: 3},
					idNumber: {required: false, minlength: 13, maxlength: 13, digits: true},
					mobile: {required: true, mobile: true},
					salesAmountOffered: {number: true},
					overAllowance: {number: true},
					standInValue: {number: true},
					projectedRetail: {number: true},
					plannedMargin: {number: true},
					vehicleYear: "required",
					vehicleCategory: "required",
					
					vehicleMake: { required: function(){ return $('#vehicleCategory').val() != '8'; } },
					vehicleModel: { required: function(){ return $('#vehicleCategory').val() != '8'; } },
					vehicleType: { required: function(){ return $('#vehicleCategory').val() != '8'; } },
					
					vehicleMakeManual: { required: function(){ return $('#vehicleCategory').val() == '8' && _w.valuationview.itemId == 0; } },
					vehicleModelManual: { required: function(){ return $('#vehicleCategory').val() == '8' && _w.valuationview.itemId == 0; } },
					vehicleTypeManual: { required: function(){ return $('#vehicleCategory').val() == '8' && _w.valuationview.itemId == 0; } },
					
					
					vehicleFuelType: "required",
					vehicleTransmissionType: "required",
					registrationNumber: "required",
					km: { required: true, digits: true }
				};
				for (var i = 0; i < damages.length; i++)
				{
					rules['damage' + damages[i].value + 'Amount'] = {number: true};
				}
				$('#frmValuationView').validate({
					"rules": rules,
					messages: {
						firstName: {
							minlength: "This field is required."
						},
						familyName: {
							minlength: "This field is required."
						},
						idNumber: {
							minlength: "Must be 13 digits.",
							maxlength: "Must be 13 digits."
						},
						vehicleYear : "This field is required.",
						vehicleCategory : "This field is required.",
						
						vehicleMake : "This field is required.",
						vehicleModel : "This field is required.",
						vehicleType : "This field is required.",
						
						vehicleMakeManual : "This field is required.",
						vehicleModelManual : "This field is required.",
						vehicleTypeManual : "This field is required.",
						
						
						vehicleFuelType : "This field is required.",
						vehicleTransmissionType : "This field is required.",
						registrationNumber : "This field is required.",
						km : {required: "This field is required."}
					},
					invalidHandler: function(event, validator) {
					    var errors = validator.numberOfInvalids();
					    if (0 < _w.valuationview.validations && errors) {
					      var message = errors == 1
					        ? 'You missed 1 field. It has been highlighted'
					        : 'You missed ' + errors + ' fields. They have been highlighted';
					      alert(message);
					    }
					    _w.valuationview.validations++;
					},
					submitHandler: function( form ) {
						$('#btnUpdate').prop('disabled', true);
						var data = _w.valuationview._prepValuationUpdateData();
						App.API.execTask(
							'updateValuation:' + _w.valuationview.itemId, data, {},
							_w.valuationview._onValuationUpdated, _w.taskExecError
						);
					}
				});
				try {
					_w.valuationview.validations = 0;
					$('#frmValuationView').valid();
				} catch(err) {}
				$('label.error').remove();
				$('.valid').removeClass('valid');
			});
		},

		_onTuReady : function ()
		{
			App.API.execTask(
					'TransUnionFromMmCode', {
						Filter : {
							vehicleYear : parseInt($('#vehicleYear').val()),
							type : parseInt($('#vehicleType').val())
						}
				}, {},
				_w.valuationview._onTuReceived
			);
		},

		_onTuReceived : function ( response )
		{
			$('#btnFetchTu').prop('disabled', false);
			if ('Success' != response.Data.Status)
			{
				alert(response.Data.Status);
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
			$('#retailPrice').val(vals.RetailPrice);
			$('#tradePrice').val(vals.TradePrice);
			$('#MmCode').val(vals.MmCode);
			_w.valuationview.ti.hydrateParam('infRetailPrice', 'R ' + vals.RetailPrice);
			_w.valuationview.ti.hydrateParam('infTradePrice', 'R ' + vals.TradePrice);
			_w.valuationview.ti.hydrateParam('infMmCode', ' ' + vals.MmCode);

		},

		_prepValuationUpdateData : function()
		{
			var data = _w.valuationview.ti.harvest();
			data.km = '' == data.km
				? 0
				: parseInt(data.km);
			var retailPrice = $('#retailPrice').val();
			var tradePrice  = $('#tradePrice').val();
			var mmCode = $('#MmCode').val();

			data.retailPrice = ('' == retailPrice)
				? 0.00
				: parseFloat(retailPrice);
			data.tradePrice = ('' == tradePrice)
				? 0.00
				: parseFloat(tradePrice);
			delete data.damageTotal;

			delete data.amountOffered;
//			if ('' == data.overAllowance)
//			{
//				delete data.overAllowance;
//			}

			if ('' == data.overAllowance)
			{
			    delete data.overAllowance;
			}
			else
			{
				data.overAllowance = parseFloat(data.overAllowance);
			}

			if ('' == data.standInValue)
			{
				delete data.standInValue;
			}
			else
			{
				data.standInValue = parseFloat(data.standInValue);
			}

			if ('' == data.projectedRetail)
			{
				delete data.projectedRetail;
			}
			else
			{
				data.projectedRetail = parseFloat(data.projectedRetail);
			}

			if ('' == data.plannedMargin)
			{
				delete data.plannedMargin;
			}
			else
			{
				data.plannedMargin = parseFloat(data.plannedMargin);
			}

			if ('' == data.mainImage)
			{
				delete data.mainImage;
			}
			if ('' == data.leftImage)
			{
				delete data.leftImage;
			}
			if ('' == data.backImage)
			{
				delete data.backImage;
			}
			if ('' == data.engineImage)
			{
				delete data.engineImage;
			}
			if ('' == data.frontImage)
			{
				delete data.frontImage;
			}
			if ('' == data.rightImage)
			{
				delete data.rightImage;
			}
			if ('' == data.interiorImage)
			{
				delete data.interiorImage;
			}
			if ('' == data.natisImage)
			{
				delete data.natisImage;
			}
			delete data.clubs;


			var postData = {Stock:{}, Valuation:{}};
			var valuationFields = [
			                       "firstName","familyName","idNumber","mobile",
			                       "email","department","amountOffered","overAllowance",
			                       "standInValue","projectedRetail","plannedMargin",
			                       "salesProfile","amountOffered","salesComments"
			                       ];
			for (var field in data)
			{
				if (-1 == valuationFields.indexOf(field))
				{
					postData.Stock[field] = data[field];
				}
				else
				{
					postData.Valuation[field] = data[field];
				}
			}
			if ('' == postData.Valuation.idNumber)
			{
				delete postData.Valuation.idNumber;
			}
			if ('' == postData.Valuation.email)
			{
				delete postData.Valuation.email;
			}

			return postData;
		},

		_onValuationUpdated : function( response )
		{
			window.location.hash = '/valuations';
		}

	};

})();