;(function(){

	//-- Ensure that we have a usable console object so that we don't crash finicky browsers.
	if (!window.console)
	{
		var names = [
			    "log", "debug", "info", "warn", "error",
			    "assert", "dir", "dirxml", "group", "groupEnd", "time",
			    "timeEnd", "count", "trace", "profile", "profileEnd"
		    ],
		    i,
		    l = names.length,
		    noOp = function () {};
		window.console = {};
		for (i = 0; i < l; i = i + 1)
		{
			window.console[names[i]] = noOp;
		}
	}

	window._w = {

		itemId    : null,
		itemData  : null,
		formMeta  : null,
		apeLoaded : false,
		apeLive   : false,
		checkBoxChanged : false,


		onSwitchTemplatePublished : function()
		{
			$('.navbar li').hide();
			$('#su_container').hide();
			$('#btnPortal').click(function() {
				_w.initPortal();
				if (App.companyData.group == '' || App.companyData.group == null)
				{
					window.location.hash = '/valuations';
				}
				window.location.hash = '/' + App.companyData.group.landingPage;
			});
			$('#btnAdmin').click(function() {
				_w.initAdmin();
				window.location.hash = '/admin';
			});
		},

		onAdminTemplatePublished : function()
		{
			// nothing to do here yet, empty landing page for now.
		},

		initBrochure : function()
		{
			// show brochure menu

			/*$('#MobiPublicMenu').hide();
			$('#MobiBrochureMenu').show();
			$('#MobiPortalMenu').remove();*/

			App.Event.listen(
		    		'onLoginPageTemplatePublished', 'Controller.Published:login',
		    		$.proxy( _w.onLoginPageTemplatePublished, this ), 'Recurring'
		    		);
			App.Event.listen(
		    		'onForgotPageTemplatePublished', 'Controller.Published:forgot',
		    		$.proxy( _w.onForgotPageTemplatePublished, this ), 'Recurring'
		    		);
			App.Event.listen(
		    		'onTemplateReady', 'Template.Ready:register',
		    		$.proxy( _w.register.onTemplateReady, this, 'register' ), 'Recurring'
		    		);
			App.Event.listen(
		    		'onTemplatePublished', 'Controller.Published:register',
		    		$.proxy( _w.register.onTemplatePublished, this, 'register' ), 'Recurring'
		    		);

			App.Event.listen(
		    		'onTemplateReady', 'Template.Ready:dealerhome',
		    		$.proxy( _w.home.onTemplateReady, this, 'dealerhome' ), 'Recurring'
		    		);
			App.Event.listen(
		    		'onTemplatePublished', 'Controller.Published:dealerhome',
		    		$.proxy( _w.home.onTemplatePublished, this, 'dealerhome' ), 'Recurring'
		    		);

			// Public Valuation
			App.Event.listen(
		    		'onValuationViewTemplateReadyMain', 'Template.Ready:publicvaluation',
		    		$.proxy( _w.publicvaluation.onValuationViewTemplateReady, this, 'publicvaluation' ), 'Recurring'
		    		);
		    App.Event.listen(
		    		'onValuationViewPublishedMain', 'Controller.Published:publicvaluation',
		    		$.proxy( _w.publicvaluation.onValuationViewPublished, this, 'publicvaluation' ), 'Recurring'
		    		);

            App.Event.listen(
                'onCustomerValuationViewTemplateReadyMain', 'Template.Ready:customervaluation',
                $.proxy( _w.customervaluation.onCustomerValuationViewTemplateReady, this, 'customervaluation' ), 'Recurring'
            );
            App.Event.listen(
                'onCustomerValuationViewPublishedMain', 'Controller.Published:customervaluation',
                $.proxy( _w.customervaluation.onCustomerValuationViewPublished, this, 'customervaluation' ), 'Recurring'
            );

            App.Event.listen(
                'onCustomerCompleteValuationViewTemplateReadyMain', 'Template.Ready:customercompletevaluation',
                $.proxy( _w.customercompletevaluation.onCustomerCompleteValuationViewTemplateReady, this, 'customercompletevaluation' ), 'Recurring'
            );
            App.Event.listen(
                'onCustomerCompleteValuationViewPublishedMain', 'Controller.Published:customercompletevaluation',
                $.proxy( _w.customercompletevaluation.onCustomerCompleteValuationViewPublished, this, 'customercompletevaluation' ), 'Recurring'
            );

		},

		initAdmin : function()
		{

			$('#PublicMenu').remove();
			$('#MobiPublicMenu').remove();
			$('#BrochureMenu').remove();
			$('#MobiBrochureMenu').remove();
			$('#PortalMenu').show();

			/*
			 * Setup permissions
			 */
			App.allowedPages = {};
			true == App.permissions.adminPage
				? $('.b_permissions').show() && (App.allowedPages.permissions = true)
				: $('.b_permissions').hide() && (App.allowedPages.permissions = false);

			true == App.permissions.adminRegistration
				? $('.b_registration').show() && (App.allowedPages.registration = true)
				: $('.b_registration').hide() && (App.allowedPages.registration = false);

			true == App.permissions.adminReport
				? $('.b_reports').show() && (App.allowedPages.reports = true)
				: $('.b_reports').hide() && (App.allowedPages.reports = false);

			true == App.permissions.adminDealer
				? $('.b_dealers').show() && (App.allowedPages.dealers = true)
				: $('.b_dealers').hide() && (App.allowedPages.dealers = false);
			true == App.permissions.adminDealer
				? $('.b_groups').show() && (App.allowedPages.dealers = true)
				: $('.b_groups').hide() && (App.allowedPages.dealers = false);
			true == App.permissions.adminDealer
				? $('.b_divisions').show() && (App.allowedPages.dealers = true)
				: $('.b_divisions').hide() && (App.allowedPages.dealers = false);

			true == App.permissions.adminCommunication
				? $('.b_communication').show() && (App.allowedPages.communication = true)
				: $('.b_communication').hide() && (App.allowedPages.communication = false);

			true == App.permissions.adminSettings
				? $('.b_systemsettings').show() && (App.allowedPages.systemsettings = true)
				: $('.b_systemsettings').hide() && (App.allowedPages.systemsettings = false);

			true == App.permissions.adminUser
				? $('.b_systemusers').show() && (App.allowedPages.systemusers = true)
				: $('.b_systemusers').hide() && (App.allowedPages.systemusers = false);

			true == App.permissions.adminAuction
				? $('.b_auctions').show() && (App.allowedPages.systemauctions = true)
				: $('.b_auctions').hide() && (App.allowedPages.systemauctions = false);

			true == App.permissions.adminPage
				? $('.b_newsletters').show() && (App.allowedPages.newsletters = true)
				: $('.b_newsletters').hide() && (App.allowedPages.newsletters = false);


			/*
			 * Setup page listeners.
			 */
			App.Event.listen(
		    		'onAdminTemplatePublished', 'Controller.Published:admin',
		    		$.proxy( _w.onAdminTemplatePublished, this, 'admin' ), 'Recurring'
		    		);
			if (true == App.permissions.adminPage)
			{
				// Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:userpermissions',
			    		$.proxy( _w.userpermissions.onTemplateReady, this, 'userpermissions' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:userpermissions',
			    		$.proxy( _w.userpermissions.onTemplatePublished, this, 'userpermissions' ), 'Recurring'
			    		);

				// Edit
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:viewuserpermissions',
			    		$.proxy( _w.viewuserpermissions.onTemplateReady, this, 'viewuserpermissions' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:viewuserpermissions',
			    		$.proxy( _w.viewuserpermissions.onTemplatePublished, this, 'viewuserpermissions' ), 'Recurring'
			    		);

				// Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:newsletters',
			    		$.proxy( _w.newsletters.onTemplateReady, this, 'newsletters' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:newsletters',
			    		$.proxy( _w.newsletters.onTemplatePublished, this, 'newsletters' ), 'Recurring'
			    		);

				// Edit
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:newsletterview',
			    		$.proxy( _w.newsletterview.onTemplateReady, this, 'newsletterview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:newsletterview',
			    		$.proxy( _w.newsletterview.onTemplatePublished, this, 'newsletterview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplateDestruct', 'Controller.RemovingPage:newsletterview',
			    		$.proxy( _w.newsletterview.onTemplateDestruct, this, 'newsletterview' ), 'Recurring'
			    		);
			}
			if (true == App.permissions.adminDealer)
			{
				// Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:dealers',
			    		$.proxy( _w.dealers.onTemplateReady, this, 'dealers' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:dealers',
			    		$.proxy( _w.dealers.onTemplatePublished, this, 'dealers' ), 'Recurring'
			    		);

				// Edit
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemdealerview',
			    		$.proxy( _w.systemdealerview.onTemplateReady, this, 'systemdealerview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemdealerview',
			    		$.proxy( _w.systemdealerview.onTemplatePublished, this, 'systemdealerview' ), 'Recurring'
			    		);
			}
			if (true == App.permissions.adminSettings)
			{
				// XmlRpc Request Grid
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:xmlrpcrequestlog',
						$.proxy( _w.xmlrpcrequestlog.onTemplateReady, this, 'xmlrpcrequestlog' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:xmlrpcrequestlog',
						$.proxy( _w.xmlrpcrequestlog.onTemplatePublished, this, 'xmlrpcrequestlog' ), 'Recurring'
				);
				// XmlRpc Callback Grid
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:xmlrpccallbacklog',
						$.proxy( _w.xmlrpccallbacklog.onTemplateReady, this, 'xmlrpccallbacklog' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:xmlrpccallbacklog',
						$.proxy( _w.xmlrpccallbacklog.onTemplatePublished, this, 'xmlrpccallbacklog' ), 'Recurring'
				);
				// XmlRpc Client Grid
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:xmlrpcclients',
						$.proxy( _w.xmlrpcclients.onTemplateReady, this, 'xmlrpcclients' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:xmlrpcclients',
						$.proxy( _w.xmlrpcclients.onTemplatePublished, this, 'xmlrpcclients' ), 'Recurring'
				);
				// XmlRpc Client Edit
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:xmlrpcclientview',
						$.proxy( _w.systemxmlrpcclientview.onTemplateReady, this, 'xmlrpcclientview' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:xmlrpcclientview',
						$.proxy( _w.systemxmlrpcclientview.onTemplatePublished, this, 'xmlrpcclientview' ), 'Recurring'
				);

				// System Config
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:configview',
			    		$.proxy( _w.configview.onTemplateReady, this, 'configview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:configview',
			    		$.proxy( _w.configview.onTemplatePublished, this, 'configview' ), 'Recurring'
			    		);

				// Accessories
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:accessories',
			    		$.proxy( _w.accessories.onTemplateReady, this, 'accessories' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:accessories',
			    		$.proxy( _w.accessories.onTemplatePublished, this, 'accessories' ), 'Recurring'
	    				);

				// Damages
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:damages',
			    		$.proxy( _w.damages.onTemplateReady, this, 'damages' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:damages',
			    		$.proxy( _w.damages.onTemplatePublished, this, 'damages' ), 'Recurring'
	    				);

				// Increments
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:increments',
						$.proxy( _w.increments.onTemplateReady, this, 'increments' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:increments',
						$.proxy( _w.increments.onTemplatePublished, this, 'increments' ), 'Recurring'
				);

				// Groups
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:groups',
						$.proxy( _w.groups.onTemplateReady, this, 'groups' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:groups',
						$.proxy( _w.groups.onTemplatePublished, this, 'groups' ), 'Recurring'
				);

				// Divisions
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:divisions',
						$.proxy( _w.divisions.onTemplateReady, this, 'divisions' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:divisions',
						$.proxy( _w.divisions.onTemplatePublished, this, 'divisions' ), 'Recurring'
				);

				// Public Holidays
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:holidays',
						$.proxy( _w.holidays.onTemplateReady, this, 'holidays' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:holidays',
						$.proxy( _w.holidays.onTemplatePublished, this, 'holidays' ), 'Recurring'
				);

				// Regional Manager
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:regionalmanager',
						$.proxy( _w.regionalmanager.onTemplateReady, this, 'regionalmanager' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:regionalmanager',
						$.proxy( _w.regionalmanager.onTemplatePublished, this, 'regionalmanager' ), 'Recurring'
				);

				// Open Days
				App.Event.listen(
						'onTemplateReady', 'Template.Ready:opendays',
						$.proxy( _w.opendays.onTemplateReady, this, 'opendays' ), 'Recurring'
				);
				App.Event.listen(
						'onTemplatePublished', 'Controller.Published:opendays',
						$.proxy( _w.opendays.onTemplatePublished, this, 'opendays' ), 'Recurring'
				);
			}
			if (true == App.permissions.adminUser)
			{
				// Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemusers',
			    		$.proxy( _w.systemusers.onTemplateReady, this, 'systemusers' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemusers',
			    		$.proxy( _w.systemusers.onTemplatePublished, this, 'systemusers' ), 'Recurring'
			    		);

				// Edit
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemuserview',
			    		$.proxy( _w.systemuserview.onTemplateReady, this, 'systemuserview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemuserview',
			    		$.proxy( _w.systemuserview.onTemplatePublished, this, 'systemuserview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:changepinview',
			    		$.proxy( _w.systemuserview.onTemplatePublished, this, 'changepinview' ), 'Recurring'
			    		);

				// Permissions
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:override',
			    		$.proxy( _w.override.onTemplateReady, this, 'override' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:override',
			    		$.proxy( _w.override.onTemplatePublished, this, 'override' ), 'Recurring'
			    		);
			}
			if (true == App.permissions.adminAuction)
			{
				// Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemauctions',
			    		$.proxy( _w.systemauctions.onTemplateReady, this, 'systemauctions' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemauctions',
			    		$.proxy( _w.systemauctions.onTemplatePublished, this, 'systemauctions' ), 'Recurring'
			    		);

				// Edit
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systembidview',
			    		$.proxy( _w.systembidview.onTemplateReady, this, 'systembidview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systembidview',
			    		$.proxy( _w.systembidview.onTemplatePublished, this, 'systembidview' ), 'Recurring'
			    		);

				// Dispute Grid
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemdisputes',
			    		$.proxy( _w.systemdisputes.onTemplateReady, this, 'systemdisputes' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemdisputes',
			    		$.proxy( _w.systemdisputes.onTemplatePublished, this, 'systemdisputes' ), 'Recurring'
			    		);

				// Edit Dispute
				App.Event.listen(
			    		'onTemplateReady', 'Template.Ready:systemdisputeview',
			    		$.proxy( _w.systemdisputeview.onTemplateReady, this, 'systemdisputeview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onTemplatePublished', 'Controller.Published:systemdisputeview',
			    		$.proxy( _w.systemdisputeview.onTemplatePublished, this, 'systemdisputeview' ), 'Recurring'
			    		);
			}
		},

		initPortal : function()
		{
            App.Template.retrieve( 'page', 'valuationview');
			/*
			 * Setup permissions
			 */
			App.allowedPages = {};
			App.allowedPages.contact = true;
			true == App.permissions.auctionPage
				? $('.b_auction').show() && (App.allowedPages.auction = true)
				: $('.b_auction').hide() && (App.allowedPages.auction = false);

			true == App.permissions.stockPage
				? $('.b_stock').show() && (App.allowedPages.stock = true)
				: $('.b_stock').hide() && (App.allowedPages.stock = false);

			App.companyData.dealerType == 'Trade Center'
				? $('.b_tcstock').show() && (App.allowedPages.tcstock = true)
				: $('.b_tcstock').hide() && (App.allowedPages.tcstock = false);

			true == App.permissions.valuationPage
				? $('.b_valuations').show() && (App.allowedPages.valuations = true)
				: $('.b_valuations').hide() && (App.allowedPages.valuations = false);
        
     		 true == App.permissions.historicalPage
				? $('.b_historicaldata').show() && (App.allowedPages.historicaldata = true)
				: $('.b_historicaldata').hide() && (App.allowedPages.historicaldata = false);

			true == App.permissions.settingsPage
				? $('.b_settings').show() && (App.allowedPages.settings = true)
				: $('.b_settings').hide() && (App.allowedPages.settings = false);

			true == App.permissions.pgPage
				? $('.b_priceGuide').show() && (App.allowedPages.priceguide = true)
				: $('.b_priceGuide').hide() && (App.allowedPages.priceguide = false);

            //if(true == App.companyData.publicCentre && true == App.permissions.valuationPage && true == App.permissions.valuationCalendar)
            if(true == App.permissions.valuationCalendar)
            {
                console.log('show b_valuationcalandar');

                $('.b_valuationCalendar').show();

                $('.b_valuationCalendar').removeClass('hide');

                App.Event.listen(
                    'onValuationCalendarTemplateReady', 'Template.Ready:valuationcalendar',
                    $.proxy( _w.valuationcalendar.onValuationCalendarTemplateReady, this, 'valuationcalendar' ), 'Recurring'
                );
                App.Event.listen(
                    'onValuationCalendarPublished', 'Controller.Published:valuationcalendar',
                    $.proxy( _w.valuationcalendar.onValuationCalendarPublished, this, 'valuationcalendar' ), 'Recurring'
                );

                App.Event.listen(
                    'onValuationAppointmentEditTemplateReady', 'Template.Ready:appointmentedit',
                    $.proxy( _w.appointmentedit.onValuationAppointmentEditTemplateReady, this, 'appointmentedit' ), 'Recurring'
                );
                App.Event.listen(
                    'onValuationAppointmentEditPublished', 'Controller.Published:appointmentedit',
                    $.proxy( _w.appointmentedit.onValuationAppointmentEditPublished, this, 'appointmentedit' ), 'Recurring'
                );
            }


			$('#PublicMenu').remove();
			$('#MobiPublicMenu').remove();
			$('#BrochureMenu').remove();
			$('#MobiBrochureMenu').remove();
			$('#PortalMenu').show();
			$('#MobiPortalMenu').show();

			/*
			 * Setup page listeners.
			 */
      if (true == App.permissions.historicalPage)
			{
        App.Event.listen(
			    		'onHistoricaldataPageTemplateReady', 'Template.Ready:historicaldata',
			    		$.proxy( _w.historicaldata.onHistoricaldataPageTemplateReady, this, 'historicaldata' ), 'Recurring'
			    		);
        App.Event.listen(
			    		'onHistoricGridPublished', 'Controller.Published:historicaldata',
			    		$.proxy( _w.historicaldata.onHistoricGridPublished, this, 'historicaldata' ), 'Recurring'
			    		);
        				// Auction History View
		App.Event.listen(
			    		'onHistoryViewTemplateReady', 'Template.Ready:historyview',
			    		$.proxy( _w.historyview.onHistoryViewTemplateReady, this, 'historyview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onHistoryViewPublished', 'Controller.Published:historyview',
			    		$.proxy( _w.historyview.onHistoryViewPublished, this, 'historyview' ), 'Recurring'
			    		);

     	 }
      
			if (true == App.permissions.auctionPage)
			{
				// Auction Grid
				App.Event.listen(
			    		'onAuctionPageTemplateReady', 'Template.Ready:auction',
			    		$.proxy( _w.auction.onAuctionPageTemplateReady, this, 'auction' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onAuctionGridPublished', 'Controller.Published:auction',
			    		$.proxy( _w.auction.onAuctionGridPublished, this, 'auction' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onAuctionDestruct', 'Controller.RemovingPage:auction',
			    		$.proxy( _w.auction.onPageDestruct, this, 'auction' ), 'Recurring'
			    		);

				// Auction Bid View
				App.Event.listen(
			    		'onBidViewTemplateReady', 'Template.Ready:bidview',
			    		$.proxy( _w.bidview.onBidViewTemplateReady, this, 'bidview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onBidViewPublished', 'Controller.Published:bidview',
			    		$.proxy( _w.bidview.onBidViewPublished, this, 'bidview' ), 'Recurring'
			    		);

				// Auction Question View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:questionview',
						$.proxy( _w.questionview.onViewTemplateReady, this, 'questionview' ), 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:questionview',
						$.proxy( _w.questionview.onViewPublished, this, 'questionview' ), 'Recurring'
				);

				// Auction Reply View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:replyview',
						$.proxy( _w.replyview.onViewTemplateReady, this, 'replyview' ), 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:replyview',
						$.proxy( _w.replyview.onViewPublished, this, 'replyview' ), 'Recurring'
				);

				// Auction Retail View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:retailview',
						$.proxy( _w.retailview.onViewTemplateReady, this, 'retailview' ), 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:retailview',
						$.proxy( _w.retailview.onViewPublished, this, 'retailview' ), 'Recurring'
				);
			}
			// they dont have rights on auctionPage so buzz off to settings page
			else
			{
				// Auction Grid
				App.Event.listen(
			    		'onAuctionPageTemplateReady', 'Template.Ready:auction',
			    		function(){ window.location.hash = '/settings'; }, 'Recurring'
			    		);
				App.Event.listen(
			    		'onAuctionGridPublished', 'Controller.Published:auction',
			    		function(){ window.location.hash = '/settings'; }, 'Recurring'
			    		);
				App.Event.listen(
			    		'onAuctionDestruct', 'Controller.RemovingPage:auction',
			    		function(){ window.location.hash = '/settings'; }, 'Recurring'
			    		);

				// Auction Bid View
				App.Event.listen(
			    		'onBidViewTemplateReady', 'Template.Ready:bidview',
			    		function(){ window.location.hash = '/settings'; }, 'Recurring'
			    		);
				App.Event.listen(
			    		'onBidViewPublished', 'Controller.Published:bidview',
			    		function(){ window.location.hash = '/settings'; }, 'Recurring'
			    		);


				// Auction Question View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:questionview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:questionview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);

				// Auction Reply View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:replyview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:replyview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);

				// Auction Retail View
				App.Event.listen(
						'onViewTemplateReady', 'Template.Ready:retailview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);
				App.Event.listen(
						'onViewPublished', 'Controller.Published:retailview',
						function(){ window.location.hash = '/settings'; }, 'Recurring'
				);

			}


			if (App.companyData.dealerType == 'Trade Center')
			{
				// TC Stock Grid
				App.Event.listen(
						'onStockPageTemplateReady', 'Template.Ready:tcstock',
						$.proxy( _w.tcstock.onStockPageTemplateReady, this, 'tcstock' ), 'Recurring'
				);
				App.Event.listen(
						'onStockPublished', 'Controller.Published:tcstock',
						$.proxy( _w.tcstock.onStockPublished, this, 'tcstock' ), 'Recurring'
				);
				App.Event.listen(
						'onStockDestruct', 'Controller.RemovingPage:tcstock',
						$.proxy( _w.tcstock.onPageDestruct, this, 'tcstock' ), 'Recurring'
				);

				// TC Stock View
				App.Event.listen(
						'onStockViewTemplateReady', 'Template.Ready:tcstockview',
						$.proxy( _w.tcstockview.onStockViewTemplateReady, this, 'tcstockview' ), 'Recurring'
				);
				App.Event.listen(
						'onStockViewPublished', 'Controller.Published:tcstockview',
						$.proxy( _w.tcstockview.onStockViewPublished, this, 'tcstockview' ), 'Recurring'
				);

				// Limited TC Stock View
				App.Event.listen(
			    		'onStockViewTemplateReady', 'Template.Ready:limitedtcstockview',
			    		$.proxy( _w.tcstockview.onStockViewTemplateReady, this, 'limitedtcstockview' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onStockViewPublished', 'Controller.Published:limitedtcstockview',
			    		$.proxy( _w.tcstockview.onStockViewPublished, this, 'limitedtcstockview' ), 'Recurring'
			    		);
			}
			if (true == App.permissions.stockPage)
			{
				// Stock Grid
				App.Event.listen(
						'onStockPageTemplateReady', 'Template.Ready:stock',
						$.proxy( _w.stock.onStockPageTemplateReady, this, 'stock' ), 'Recurring'
				);
				App.Event.listen(
						'onStockPublished', 'Controller.Published:stock',
						$.proxy( _w.stock.onStockPublished, this, 'stock' ), 'Recurring'
				);
				App.Event.listen(
						'onStockDestruct', 'Controller.RemovingPage:stock',
						$.proxy( _w.stock.onPageDestruct, this, 'stock' ), 'Recurring'
				);

				// Stock View
				App.Event.listen(
			    		'onStockViewTemplateReady', 'Template.Ready:stockview',
			    		$.proxy( _w.stockview.onStockViewTemplateReady, this, 'stockview' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onStockViewPublished', 'Controller.Published:stockview',
			    		$.proxy( _w.stockview.onStockViewPublished, this, 'stockview' ), 'Recurring'
			    		);

				// Limited Stock View
				App.Event.listen(
			    		'onStockViewTemplateReady', 'Template.Ready:limitedstockview',
			    		$.proxy( _w.stockview.onStockViewTemplateReady, this, 'limitedstockview' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onStockViewPublished', 'Controller.Published:limitedstockview',
			    		$.proxy( _w.stockview.onStockViewPublished, this, 'limitedstockview' ), 'Recurring'
			    		);
			}

			if (true == App.permissions.valuationPage)
			{
				// Valuation Grid
				App.Event.listen(
			    		'onValuationPageTemplateReady', 'Template.Ready:valuations',
			    		$.proxy( _w.valuation.onValuationPageTemplateReady, this, 'valuations' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onValuationsPublished', 'Controller.Published:valuations',
			    		$.proxy( _w.valuation.onValuationsPublished, this, 'valuations' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onValuationsDestruct', 'Controller.RemovingPage:valuations',
			    		$.proxy( _w.valuation.onPageDestruct, this, 'valuations' ), 'Recurring'
			    		);

				// Valuation View
				App.Event.listen(
			    		'onValuationViewTemplateReadyMain', 'Template.Ready:valuationview',
			    		$.proxy( _w.valuationview.onValuationViewTemplateReady, this, 'valuationview' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onValuationViewPublishedMain', 'Controller.Published:valuationview',
			    		$.proxy( _w.valuationview.onValuationViewPublished, this, 'valuationview' ), 'Recurring'
			    		);

				// Limited Valuation View
				App.Event.listen(
			    		'onValuationViewTemplateReadyLimited', 'Template.Ready:limitedvaluationview',
			    		$.proxy( _w.valuationview.onValuationViewTemplateReady, this, 'limitedvaluationview' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onValuationViewPublishedLimited', 'Controller.Published:limitedvaluationview',
			    		$.proxy( _w.valuationview.onValuationViewPublished, this, 'limitedvaluationview' ), 'Recurring'
			    		);
			}

			if (true == App.permissions.pgPage)
			{
				// Price Guide Grid
				App.Event.listen(
			    		'onPriceGuidePageTemplateReady', 'Template.Ready:priceguide',
			    		$.proxy( _w.priceguide.onPriceGuidePageTemplateReady, this, 'priceguide' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onPriceGuideGridPublished', 'Controller.Published:priceguide',
			    		$.proxy( _w.priceguide.onPriceGuideGridPublished, this, 'priceguide' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onPriceGuideDestruct', 'Controller.RemovingPage:priceguide',
			    		$.proxy( _w.priceguide.onPageDestruct, this, 'priceguide' ), 'Recurring'
			    		);

				// Price Guide Offer View
				App.Event.listen(
			    		'onOfferViewTemplateReady', 'Template.Ready:offerview',
			    		$.proxy( _w.offerview.onOfferViewTemplateReady, this, 'offerview' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onOfferViewPublished', 'Controller.Published:offerview',
			    		$.proxy( _w.offerview.onOfferViewPublished, this, 'offerview' ), 'Recurring'
			    		);
			}

			if (true == App.permissions.settingsPage)
			{
				// Settings
				App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:settings',
			    		$.proxy( _w.settings.onViewTemplateReady, this, 'settings' ), 'Recurring'
			    		);
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:settings',
			    		$.proxy( _w.settings.onViewPublished, this, 'settings' ), 'Recurring'
			    		);
				App.Event.listen(
			    		'onSettingsDestruct', 'Controller.RemovingPage:settings',
			    		$.proxy( _w.settings.onPageDestruct, this, 'settings' ), 'Recurring'
			    		);

			    // User View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:userview',
			    		$.proxy( _w.userview.onViewTemplateReady, this, 'userview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:userview',
			    		$.proxy( _w.userview.onViewPublished, this, 'userview' ), 'Recurring'
			    );

			    // Change pin
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:changepinview',
			    		$.proxy( _w.changepinview.onViewTemplateReady, this, 'changepinview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:changepinview',
			    		$.proxy( _w.changepinview.onViewPublished, this, 'changepinview' ), 'Recurring'
			    );

			    // Dealer View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:dealerview',
			    		$.proxy( _w.dealerview.onViewTemplateReady, this, 'dealerview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:dealerview',
			    		$.proxy( _w.dealerview.onViewPublished, this, 'dealerview' ), 'Recurring'
			    );

			    // Membership View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:membershipview',
			    		$.proxy( _w.membershipview.onViewTemplateReady, this, 'membershipview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:membershipview',
			    		$.proxy( _w.membershipview.onViewPublished, this, 'membershipview' ), 'Recurring'
			    );

			    // Club View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:clubview',
			    		$.proxy( _w.clubview.onViewTemplateReady, this, 'clubview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:clubview',
			    		$.proxy( _w.clubview.onViewPublished, this, 'clubview' ), 'Recurring'
			    );

			    // Club Member View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:memberview',
			    		$.proxy( _w.memberview.onViewTemplateReady, this, 'memberview' ), 'Recurring'
			    );
			    App.Event.listen(
			    		'onViewPublished', 'Controller.Published:memberview',
			    		$.proxy( _w.memberview.onViewPublished, this, 'memberview' ), 'Recurring'
			    );

			    // User View
			    App.Event.listen(
			    		'onViewTemplateReady', 'Template.Ready:disputeview',
			    		$.proxy( _w.disputeview.onViewTemplateReady, this, 'disputeview' ), 'Recurring'
			    );
			}


			/*
			 * SU filters
			 */
			if(true == App.permissions.suAccess)
			{
				App.DataStore.loadSelectListData('sugroups', true, 'Company', 'Group.SelectList');
			    App.DataStore.setData('sudivisions', []);
			    App.DataStore.setData('sucompanies', []);
			    var sugroupMeta = {
						type        : 'select',
						id          : 'sugroup',
						selectEmpty : 'All',
						dataStoreId : 'sugroups',
						value       : false == App.permissions.suGroupFull
										? App.companyData.group.id
										: (App.Sudo && App.Sudo.GroupId ? App.Sudo.GroupId : ''),
						onChange    : function () {
							if (!App.DataStore.getItem('BuildSelect:sugroup', false))
							{
								if (true == App.permissions.suGroupFull)
							    {
									var leVal = $(this).val();

									if ("" == leVal)
									{
										App.DataStore.setData('sudivisions', []);
										App.DataStore.setData('sucompanies', []);
										$('#x_sudivision').hide();
										$('#x_sucompany').hide();
									}
									else
									{
										App.DataStore.loadSelectListData(
												'sudivisions', false, 'Company', 'GroupDivision.SelectList',
												null, {Filter:{group:$(this).val()}}
												);
										App.DataStore.setData('sucompanies', []);
										$('#sudivision').selectpicker('val', "");
										$('#sucompany').selectpicker('val', "");
										$('#x_sudivision').show();
										$('#x_sucompany').hide();
									}

									var leVal = '' == $(this).val() ? 0 : $(this).val();
									App.API.execTask(
											'setSu', {Sudo:{Group:leVal}}, {},
											function(){
												App.Event.trigger('SuChange', {});
												App.DataStore.loadSelectListGroup([
												  {dataId: 'sales', isStatic: false, workspace: 'User', task: 'Profile.SalesList'},
												  {dataId: 'managers', isStatic: false, workspace: 'User', task: 'Profile.ManagerList'},
												]);
											}, _w.taskExecError
										);
							    }


							}
							else
							{
								if ("" != $(this).val())
								{
									App.DataStore.loadSelectListData(
											'sudivisions', false, 'Company', 'GroupDivision.SelectList',
											null, {Filter:{group:$(this).val()}}
											);
									$('#x_sudivision').show();
								}
							}
						}
					};

			    var sudivisionMeta = {
						type        : 'select',
						id          : 'sudivision',
						selectEmpty : 'All',
						dataStoreId : 'sudivisions',
						value       : false == App.permissions.suGroupFull && false == App.permissions.suDivisionFull
											? (null != App.companyData.groupDivision ? App.companyData.groupDivision.id : null)
											: (App.Sudo && App.Sudo.DivisionId ? App.Sudo.DivisionId : ''),
						onChange    : function () {
							if (!App.DataStore.getItem('BuildSelect:sudivision', false))
							{

								if (true == App.permissions.suGroupFull
										|| true == App.permissions.suDivisionFull)
								{
									var leVal = $(this).val();

									if ("" == leVal)
									{
										App.DataStore.setData('sucompanies', []);
										$('#x_sucompany').hide();
									}
									else
									{
										App.DataStore.loadSelectListData(
												'sucompanies', false, 'Company', 'Company.SelectList',
												null, {Filter:{groupDivision:$(this).val()}}
												);
										$('#x_sucompany').show();
										$('#sucompany').selectpicker('val', "");
									}

									var leVal = '' == $(this).val() ? 0 : $(this).val();
									App.API.execTask(
											'setSu', {Sudo:{Division:leVal}}, {},
											function(){
												App.Event.trigger('SuChange', {});
												App.DataStore.loadSelectListGroup([
												  {dataId: 'sales', isStatic: false, workspace: 'User', task: 'Profile.SalesList'},
												  {dataId: 'managers', isStatic: false, workspace: 'User', task: 'Profile.ManagerList'},
												]);
											}, _w.taskExecError
										);
								}


							}
							else
							{
								if("" != $(this).val())
								{
									App.DataStore.loadSelectListData(
											'sucompanies', false, 'Company', 'Company.SelectList',
											null, {Filter:{groupDivision:$(this).val()}}
											);
									$('#x_sucompany').show();
								}
							}
						}
					};

			    var sucompanyMeta = {
						type        : 'select',
						id          : 'sucompany',
						selectEmpty : 'All',
						dataStoreId : 'sucompanies',
						value       : false == App.permissions.suGroupFull
										&& false == App.permissions.suDivisionFull
										&& false == App.permissions.suCompanyFull
							? App.companyData.id
							: (App.Sudo && App.Sudo.CompanyId ? App.Sudo.CompanyId : ''),
						onChange    : function () {
							if (!App.DataStore.getItem('BuildSelect:sucompany', false))
							{
								if (true == App.permissions.suGroupFull
										|| true == App.permissions.suDivisionFull
										|| true == App.permissions.suCompanyFull)
								{
									var leVal = '' == $(this).val() ? 0 : $(this).val();
									App.API.execTask(
											'setSu', {Sudo:{Company:leVal}}, {},
											function(){
												App.Event.trigger('SuChange', {});
												App.DataStore.loadSelectListGroup([
												  {dataId: 'sales', isStatic: false, workspace: 'User', task: 'Profile.SalesList'},
												  {dataId: 'managers', isStatic: false, workspace: 'User', task: 'Profile.ManagerList'},
												]);
											}, _w.taskExecError
										);
								}
							}
						}
					};

			    $('#x_sugroup').html(App.ElementLibrary.Field.html(sugroupMeta, null));
			    App.ElementLibrary.Field.bind( 'x', sugroupMeta );
			    if (false == App.permissions.suGroupFull)
			    {
			    	$('#sugroup').attr('disabled', true);
			    }

			    $('#x_sudivision').html(App.ElementLibrary.Field.html(sudivisionMeta, null));
			    App.ElementLibrary.Field.bind( 'x', sudivisionMeta );
			    if (false == App.permissions.suGroupFull
			    		&& false == App.permissions.suDivisionFull)
			    {
			    	$('#sudivision').attr('disabled', true);
			    }

			    $('#x_sucompany').html(App.ElementLibrary.Field.html(sucompanyMeta, null));
			    App.ElementLibrary.Field.bind( 'x', sucompanyMeta );
			    if (false == App.permissions.suGroupFull
			    		&& false == App.permissions.suDivisionFull
			    		&& false == App.permissions.suCompanyFull)
			    {
			    	$('#sucompany').attr('disabled', true);
			    }

			    $('#x_sudivision').hide();
				$('#x_sucompany').hide();
				$('#su_container').show();
			}
		},

		filterIfnotEmpty : function( filter, element, field, op, append, defaultValue )
		{
			append = (append)
				? append
				: '';
			if ('' != $('#' + element).val() && null != $('#' + element).val())
			{
				op = op ? op + ' ' : '';
				var val = $('#' + element).val();

				if ($('#' + element).hasClass('selectpicker'))
				{
					op = '';
				}
				else
				{
					//val = ('' == val || !isNaN(val) || '' != op)
					//	? val
					//	: '%' + val + '%';

                    val = ('' == val || '' != op)
                        ? val
                        : '%' + val + '%';
				}
				if (filter.filters[field])
				{
					var nested = {};
					nested[field] = op + val + append;
					filter.filters[field + '-to'] = nested;
				}
				else
				{
					filter.filters[field] = op + val + append;
				}
				filter.count++;
			}
			return filter;
		},

		populateFilters : function( filters, map )
		{
			for (var field in map)
			{
				var nested = field.split(':');
				if (nested[1])
				{
					if (filters[nested[0]] && filters[nested[0]][nested[1]])
					{
						filters[field] = isNaN(filters[nested[0]][nested[1]]) && '%' == filters[nested[0]][nested[1]].substring(0,1)
							? filters[nested[0]][nested[1]].substring(1, filters[nested[0]][nested[1]].length - 1)
							: filters[nested[0]][nested[1]];
						$('#' + map[field]).val(filters[field]);
						$('#' + map[field] + '.selectpicker').selectpicker('refresh');
					}
				}
				else if (filters[field])
				{
					filters[field] = isNaN(filters[field]) && '%' == filters[field].substring(0,1)
						? filters[field].substring(1, filters[field].length - 1)
						: filters[field];
					$('#' + map[field]).val(filters[field]);
					$('#' + map[field] + '.selectpicker').selectpicker('refresh');
				}
			}
		},

		taskContractError : function( response )
		{

			App.API.getTask(
					'getActiveAccount', 'User', 'Profile.ActiveAccount', null,
					{}, function() {
						if ('bid4cars.nirph.com' != window.location.hostname
								&& 'bid4cars.local' != window.location.hostname
								&& 'www.bid4cars.com.na' != window.location.hostname)
						{
							alert('Please click ok to refresh this page.');
							location.reload();
						}
						console.log('------------ Task Contract Error ------------');
						console.log(response);
						console.log('--------------------------------------');
					},_w.onActiveAccountFailure
			);

		},

		taskExecError : function( response )
		{
			App.API.getTask(
					'getActiveAccount', 'User', 'Profile.ActiveAccount', null,
					{}, function() {
						if ('bid4cars.nirph.com' != window.location.hostname
								&& 'bid4cars.local' != window.location.hostname
								&& 'www.bid4cars.com.na' != window.location.hostname)
						{
							alert('Please click ok to refresh this page.');
							location.reload();
						}
						console.log('------------ Task Exec Error ------------');
						console.log(response);
						console.log('--------------------------------------');
					}, _w.onActiveAccountFailure
			);
		},

		onForgotPageTemplatePublished : function( event, eventData )
		{
			$('#email').val(App.Util.getCookie('UserEmail', ''));
			$('#frmReset').validate({
				rules: {
					email: {
						email: true
					},
					mobile: {
						mobile: true
					}
				},
				submitHandler: function( form ) {
					if ('' == $('#email').val() && '' == $('#mobile').val())
					{
						alert('Please provide email or mobile number.');
						return;
					}
					App.API.getTask(
							'reset', 'User', 'Profile.ForgotPassword', null,
							{}, function() {
								var mobile = $('#mobile').val();
								mobile = ('' == mobile)
									? ''
									: '+264' + mobile;
								var data = {
									"Reset":{
									    "email"  : $('#email').val(),
									    "mobile" : mobile
								  }};
								App.API.execTask(
									'reset', data, {},
									function(response) {
										$('#reset-fail').popover('hide');
										alert('Please check your email for your new pin.');
										window.location = '/#/login';
									}, function (data) {
										$('#reset-fail').attr('data-content', data.Message);
										$('#reset-fail').popover('show');
									}
								);
							}, _w.taskContractError
					);
				}
			});
		},

		onLoginPageTemplatePublished : function( event, eventData )
		{
			App.Util.updateCheckboxStyles($('#frmLogin'));
			$('#email').val(App.Util.getCookie('UserEmail', ''));
			$('#frmLogin').validate({
				rules: {
					email: {
						email: true,
						required: true
					},
					pin: {
						minlength: 3,
						required: true
					},
					mpin: {
						minlength: 3,
						required: true
					}
				},
				submitHandler: function( form ) {
					App.API.getTask(
							'login', 'User', 'Profile.Login', null,
							{}, function() {
								var data = {
									"Login":{
									    "email"      : $('#email').val(),
									    "pin"        : $('#pin').val()
								  }};
								App.API.execTask(
									'login', data, {},
									function(response) {
										$('#login-fail').popover('hide');
										var rem = $('#rememberMe').is(':checked')
											? $('#email').val()
											: '';
										App.Util.setCookie('UserEmail', rem, 30);
										_w.onActiveAccount(response);
									}, function (data) {
										$('#login-fail').attr('data-content', data.StatusReason);
										$('#login-fail').popover('show');
									}
								);
							}, _w.taskContractError
					);
				}
			});
		},

		synchServerTime : function()
		{
			var dt = new Date();
			App.timeDiffStart = Math.round(dt.getTime() / 1000) + 1;
			$.ajax({
				type 		: 'GET',
				dataType 	: 'json',
				url 		: window.location.protocol
							+ '//' + window.location.hostname
							+ '//servertime.php?v=' + dt.getTime()
			})
			.done( function(data) {
				var dt = new Date();
				var now = Math.round(dt.getTime() / 1000);
				if ((now - App.timeDiffStart) < 4)
				{
					App.timeDiff = now - data.time;
					setTimeout(_w.synchServerTime, 600000);
				}
				else
				{
					setTimeout(_w.synchServerTime, 5000);
				}
			});
		},

		onActiveAccount : function( response )
		{
			/*
			 * Request list of public holidays.
			 */
			$('#login_mobi').hide();
			App.API.getTask(
					'listPublicHoliday', 'Auction', 'PublicHoliday.List', null,
					{}, function() {
						App.API.execTask(
								'listPublicHoliday', {}, {},
								function(response) {
									App.DataStore.setData('publicHolidays', response.Data);
								}, _w.taskExecError
								);
					}, _w.taskContractError
					);

			/*
			 * User is authenticated.
			 */
			App.Authenticated = true;
			App.serverConfig = response.Data.config;
			delete response.Data.config;
			App.permissions = response.Data.permissions;
			delete response.Data.permissions;
			App.companyData = response.Data.company;
			App.companyData.tC = App.companyData.tradeCenter && App.companyData.tradeCenter.id
				? App.companyData.tradeCenter.id
				: false;
			delete response.Data.company;
			App.Sudo = response.Data.Sudo;
			delete response.Data.Sudo;
			App.userData = response.Data;

			//console.log("serverConfig", App.serverConfig);
			//console.log("permissions", App.permissions);
			//console.log("companyData", App.companyData);
			//console.log("Sudo", App.Sudo);
			//console.log("userData", App.userData);


			App.openDays = response.Data.auctionOpenDays;
			delete response.Data.auctionOpenDays;
			if ('Auction Buyer' == App.permissions.name
				|| 'Auction Buyer & Seller' == App.permissions.name)
			{
				if (App.companyData.group != null){
					App.companyData.group.landingPage = 'auction';
				}

			}
			if ('Auction Buyer' == App.permissions.name
				|| 'Auction Buyer & Seller' == App.permissions.name)
			{
				App.isNewAuctionUser = true;
			}


			/*
			 * Show and hook up logout button
			 */
			$('.b_logout').show();
			$('.b_logout').click(function()
			{

				$('#PortalMenu').remove();

				App.Authenticated = false;
				App.permissions = {};
				App.companyDat  = {};
				App.Sudo        = {};
				App.userData    = {};
				App.API.getTask(
						'logout:', 'User', 'Profile.Logout', null,
						{}, function() { window.location='/'; }, function() {}
					);
			});

			/*
			 * Show user details
			 */
			$('#user-details').removeClass('invisible');
			$('.auth-username').html(
					App.userData.firstName + ' ' + App.userData.familyName
			);
			$('.auth-name').html(
					App.userData.firstName
			);

			/*
			 * Init permissions and page listeners.
			 */
			var isMobile = 'none' == $('#mobiCheck').css('display');
			if (true == App.permissions.accessPortalModule
					&& false == App.permissions.accessAdminModule)
			{
				_w.initPortal();

				if (null == App.userData.lastLogin || '' == App.userData.lastLogin)
				{
					window.location.hash = '/changepinview?id=' + App.userData.id;
				}
				else if (App.redirect && '' != App.redirect && '#/' != App.redirect)
				{
					window.location =  '/' + App.redirect;
					delete App.redirect;
				}
				else
				{

					// check for mobi redirect here

					if (isMobile)
					{

						// if permissions are ok show the buttons
						if (false == App.permissions.valuationPage)
						{
							$("#mobiValuationsBtn").remove();
						}
						if (false == App.permissions.pgPage)
						{
							$("#mobiPriceGuideBtn").remove();
						}
						if (false == App.permissions.auctionPage)
						{
							$("#mobiAuctionBtn").remove();
						}

						// do a redirect to valid pages
						if (App.permissions.valuationPage)
						{
							window.location.hash = '/valuations';
						}
						else if (App.permissions.pgPage )
						{
							window.location.hash = '/priceguide';
						}
						else if (App.permissions.auctionPage)
						{
							window.location.hash = '/auction';
						}

						else
						{
							alert("Sorry you dont have any mobi permissions");
							App.Authenticated = false;
							App.permissions = {};
							App.companyDat  = {};
							App.Sudo        = {};
							App.userData    = {};
							App.API.getTask(
									'logout:', 'User', 'Profile.Logout', null,
									{}, function() { window.location='/'; }, function() {}
								);
						}
					}

					else
					{

						if (App.companyData.group == null)
						{

							window.location.hash = '/settings';

						}



						else if (false == App.permissions.valuationPage && 'valuations' == App.companyData.group.landingPage)
						{
							window.location.hash = '/settings';
						}
						else if (false == App.permissions.pgPage && 'priceguide' == App.companyData.group.landingPage)
						{
							window.location.hash = '/settings';
						}
						else if (false == App.permissions.auctionPage && 'auction' == App.companyData.group.landingPage)
						{
							window.location.hash = '/settings';
						}
						else if ('' != App.companyData.group.landingPage && null != App.companyData.group.landingPage)
						{
							window.location.hash = '/' + App.companyData.group.landingPage;
						}
						else if (null == App.companyData.group.landingPage)
						{
							window.location.hash = '/settings';
						}
						else
						{
							window.location.hash = '/settings';
						}

					}
				}
			}
			else if (false == App.permissions.accessPortalModule
					&& true == App.permissions.accessAdminModule)
			{
				_w.initAdmin();
				if ('bid4cars.local' != window.location.hostname)
				{
					window.location.hash = '/admin';
				}
				else
				{
					if(App.redirect)
					{
						window.location =  '/' + App.redirect;
						delete App.redirect;
					}
					else
					{
						window.location.hash = '/admin';
					}
				}
			}
			else if (true == App.permissions.accessPortalModule
					&& true == App.permissions.accessAdminModule)
			{
				App.Event.listen(
			    		'onSwitchTemplatePublished', 'Controller.Published:switch',
			    		$.proxy( _w.onSwitchTemplatePublished, this ), 'Recurring'
			    		);
				window.location.hash = '/switch';
			}
			else
			{
				// No permissions at all
				window.location.hash = '/home';
			}
			_w.synchServerTime();

		},

		onActiveAccountFailure : function()
		{
			/*
			 * User is not authenticated.
			 */
			App.Authenticated = false;
			$('#login_mobi').show();

			/*
			 * Hide nav
			 */
			$('#b_logout').hide();
			$('#b_stock').hide();
			$('#b_tcstock').hide();
			$('#b_valuations').hide();
     		$('#b_historicaldata').hide();
			$('#b_settings').hide();
			$('#b_priceGuide').hide();

			/*
			 * Hide user details
			 */
			$('#user-details').addClass("invisible");

			/*
			 * Initiate brochure.
			 */
			_w.initBrochure();

			_w.synchServerTime();

		}

	};

})();